/*
 * cvr_def.h          verze 1
 *
 * zkladn definice struktur, vt k programu CVREK
 *
 * (c) Pavel RAK, 1996.01.12 23:22 SE vznik souboru
 *
 */

#ifndef CVR_DEF_H

#define CVR_DEF_H

/************************* symbolick konstatny *****************************/
/* pouiteln v dalch modulech */

#define MEK 0                                   /* aktuln platforma */
#define PCCKO  1

/********************** makra bez parametr ***************************/

#define PARSOUBOR  "parametr.txt"  /* jmno souboru s parametry */

#define DELKABAFRU     1024   /* dlka pracovnho bafru pro ukldn do
                                vstupnho souboru */
#define MAXZNAK        256    /* maximln poet znak ve fontov tabulce */
#define MAXIMALNIDELKARADKU  512  /* dlka pracovnho etzce */
#define DELKANAZVUFONTU  33      /* dlka nzvu fontu v tabulce fonttbl */
#define MAXDELKAFONTU  33        /* maximln mon dlka jmna fontu v fonttbl */
#define MAXFONTPISMEN  26        /* maximln poet psmen pro pepnn
                                    font, nap. pro  RTFaa - RTFaz je to 26 */
#define DELKAPAR  25  /* nejvt mon dlka textovho parametru u RTF pޒkazu*/
#define RTFSOUBOR  "prikazy.txt"  /* jmno souboru s definicemi a konfiguranmi parametry */

/* matika */
/**********/
#define PRACPAR          6      /* poet alokovanch parametr pi vstupu do funkce */
#define MAXPRACPAR      10    /* maximln poet alokovatelnch
                                  parametr pi zpracovn vzoreku */
#define MATSOUBOR "matprik.txt"    /* jmno textu s matematickmi pޒkazy */
#define DELKAMATPAR  40  /* nejvt mon dlka textovho parametru u mat. pޒkazu*/

/************************** vtov typy ******************************/

/* kdovn font */
/******************/
typedef enum {
  MAC = 0,      /* Macintosh */
  ANSI = 1,      /* pro ostatn pouij stejn kdovn, tj. Windows, */
  PC = 1,        /* proto maj stejn hodnoty, abych v programu nemusel */
  PCA = 1        /* vdy zkoumat kdovn, pro mne sta bu MAC nebo PC */
} KODFONTU;

/* typ fontu */
/*************/
typedef enum {
  VSEOBECNY,  /* veobecn pouiteln, pouij pro ty,
                  kter nemaj sv vlastn kdovn, v programu mus
                  existovat aspo jeden font libovolnho jmna s TYPFONTU
                  VSEOBECNY, abych vbec vdl, jak pekldat etinu */
  UZIVATELSKY /* uivatelsk kdovn fontu, nap. Symbol */
} TYPFONTU;

/* vet chybovch hlen, text je ve funkci chyba() */
/******************************************************/
typedef enum {
  DEFAULT,
  NELZEOTEVRIT,
  NELZEZAVRIT,
  NENIPAMET,
  CHYBACTENI,
  CHYBAZAPISU,
  NENIPRVNIPARAMETR,
  PRILISMNOHOPARAMETRU,
  CHYBAINICIALIZACE,
  CHYBAMATINICIALIZACE,
  CHYBNYVSTUPNISOUBOR,
  DLOUHYPRIKAZ,
  NENIRTF
} KODCHYBY;

/* md ukldn do vstupnho souboru */
/**************************************/
typedef enum {
  POZNAMKY,            /* poznmku (uvozen znakem PROCENTO) */
  TEXT,                /* normln text */
  MAT,                /* matematika */
  MATMAT,              /* dvojit matematika nap. $$x^4$$ */
  NEZAVISLY,          /* ukldn nezvisl na aktulnm mdu */
  NOVYRADEK            /* zalom އdek */
} MODUKLADANI;

/* typ parametr u RTF pޒkazu */
/*******************************/
typedef enum {
  NULA,    /* rezervovno */
  JEDNA,  /* \mac - bez paramteru, samostatn pޒkaz */
  DVA,    /* \deff2 - parametr je slo za pޒkazem */
  TRI,    /* {\info {...}} - pޒkaz v zvorce, parametry v zvorce */
  CTYRI,  /* \qr ... \pard - parametr je ukonen pޒkazem \pard */
  PET,    /* {\edmins 51} - pޒkaz v zvorce, parametr slo za pޒkazem */
  SEST,    /* {\colortbl\...\....\...;\... ...} */
  SEDM,    /* {\ul ...} - parametrem je ve do konce zvorky */
  OSM      /* rezervovno */
} TYPPARAMETRU;

/* akce, kterou vykonat - kadmu symbolu odpovd vtev ve fci vykonej_fzas */
/*****************************************************************************/
typedef enum {
  UKONCIZAVORKU,
  NULUJHVEZDU,
  NASTAVFONTTBL,
  NULUJPOZNAMKY,
  UKONCIINDEX,
  OBNOVFONT,
  RESETUJOBJEKTY,
  RESETFONTBI
} AKCE;

/* typ TeXovsk skupiny */
/************************/
typedef enum {
  ZADNA,
  CENTER,
  FLUSHLEFT,
  FLUSHRIGHT,
  QUOTE
} TEXSKUPINA;

/* rodiny font */
/****************/
typedef enum {
  NIL,
  ROMAN,
  SWISS,
  MODERN,
  SCRIPT,
  DECOR,
  TECH
} RODINA;

/* typy objekt */
/****************/
typedef enum {
  NEDEFINOVAN,
  EQUATION
} OBJEKTY;

/* ezy psma */
/**************/
typedef enum {
  RM,
  BF,
  IT
} REZY;

/****************************** struktury *****************************/

/* struktura RTF pޒkaz */
/*************************/
typedef struct rpr {
  char *p_jmeno;        /* jmno pޒkazu */
  TYPPARAMETRU typpar;  /* typ parametru, slo 1 - 6 */
  char *p_pred;          /* text ped vykonnm pޒkazu */
  char *p_stred;        /* text uprosted pޒkazu */
  char *p_po;            /* text po ukonen pޒkazu */
  int poradi;            /* poad v tabulce, programov se zvyuje o 1 */
  struct rpr *p_dalsi;  /* pointer na dal pޒkaz */
} RPR, *P_RPR;

/* struktura matematickch pޒkaz */
/***********************************/
typedef struct mpr {
  int cislo;            /* slo pޒkazu 02, 03, 06 apod. */
  long kod;              /* bli kd pޒkazu nap. 00ff55 u 03 */
  int parametru;        /* poet parametr u pޒkazu (1, 2 i 0) */
  char *p_pred;          /* text ped vykonnm pޒkazu */
  char *p_stred;        /* text uprosted pޒkazu */
  char *p_po;            /* text po ukonen pޒkazu */
  int poradi;            /* poad v tabulce, programov se zvyuje o 1 */
  struct mpr *p_dalsi;  /* pointer na dal pޒkaz */
} MPR, *P_MPR;

/* struktura pro znak */
/**********************/
typedef struct znak {
  MODUKLADANI mod;    /* md ukldn: 1 - textov, 2 - matematick */
  int delka;          /* dlka znaku: 1 - psmeno, hodnota je v ascii */
                      /*           != 1 - text, hodnota je p_texposl */
  int ascii;          /* ascii hodnota znaku */
  char *p_texposl;    /* pointer na tex posloupnost nahrazujc psmeno */
} ZNAK, *P_ZNAK;

/* struktura pro font */  /* statick */
/**********************/
typedef struct font {
  char *p_nazev;          /* jmno fontu */
  TYPFONTU typ;            /* typ fontu: 0 - veobecn, 1 - uivatelsk */
  ZNAK tab_znak[MAXZNAK];  /* pole 256 znak pro substituce */
  KODFONTU kodovani;      /* pouit kdovn: 0 - mac, 1 - ansi = pc = pca */
  int poradi;              /* poad v tabulce, programov se zvyuje o 1 */
  struct font *p_dalsi;    /* pointer na dal tabulku */
} FONT, *P_FONT;

/* struktura pro substituce rodin font */  /* statick */
/****************************************/
typedef struct fontsubst {
  RODINA rodina_fontu;  /* v poad FNIL, FROMAN, ... */
  char *p_textposl;      /* TeX posloupnost nahrazujc rodinu font,
                            nap. SWISS nahrad \sf */
} FONTSUBST, *P_FONTSUBST;

/* struktura pro preambuli */  /* statick */
/***************************/
typedef struct preambule {
  char *p_text;                /* jeden އdek textu preambule */
  struct preambule *p_dalsi;  /* pointer na dal އdek */
} PREAMBULE, *P_PREAMBULE;

/* struktura pro velikosti font */  /* statick */
/*********************************/
typedef struct velfontu {
  float dolni_mez;  /* doln mez pro pouit pޒkazu pro velikost fontu */
  char *p_texposl;  /* TeX posloupnost pro pޒkaz zmny velikosti */
  struct velfontu *p_dalsi;  /* pointer na dal tabulku */
} VELFONTU, *P_VELFONTU;

              /**************** dynamick ***************/

/* RTF zsobnk */  /* dynamick */
/****************/
typedef struct rtfzas {
  AKCE cislo_akce;    /* oznaen RTF skupiny */
  int cislo_zavorky;  /* slo sloen zvorky, pro kterou je akce aktuln
                          -1 - nen to vznno na zvkorku, != -1 - je vzno
                          na zvorku */
  struct rtfzas *p_dalsi;  /* dal struktura na zsobnku */
  struct rtfzas *p_pred;  /* pedchzejc struktura na zsobnku */
  long parametr;          /* pro schovu velijakch parametr */
} RTFZAS, *P_RTFZAS;

/* struktura pro fontovou tabulku */  /* dynamick */
/**********************************/
typedef struct fonttab {
  char *p_nazev;            /* jmno definovanho fontu */
  long cislo;                /* pedan slo fontu */
  RODINA rodina_fontu;      /* rodina - NIL, ROMAN, ... */
  P_ZNAK p_tabulka_znak;    /* pointer na pole 256 ZNAK, podle kterho budu
                                pekldat jednotliv znaky tohot fontu */
  int poradi;                /* poad v tabulce, programov se zvyuje o 1 */
  struct fonttab *p_dalsi;  /* pointer na dal definovan font */
} FONTTAB, *P_FONTTAB;

/* struktura pro styly */  /* dynamick */
/***********************/
typedef struct styl {
  char *p_nazev;        /* jmno definovanho stylu */
  long cislo;            /* pedan slo stylu */
  int poradi;            /* poad v tabulce, programov se zvyuje o 1 */
  struct styl *p_dalsi;  /* pointer na dal definovan styl */
} STYL, *P_STYL;

/************************ makra s parametry ***************************/

/* PC */
/******/
#define CH(x)  {} /*    {puts(x);} */ /* vype chybov hlen na obrazovku,
                      jen pro PC, na Macintoshi to nadefinovat na hlen do
                      Alertboxu */
#define PRINT    {fputs(sp, fc); fputs("\n", fc);} /* ukldn etzce do cvr souboru */
#define TNO(x)   {fputs((x), fc); fputs("\n", fc);}  /* vypi text na obrazovku */

/* platformov nezvisl */
/*************************/
#define TW_MM(x)  ((int)(((double)(x))/((72.*20.)/25.4)))  /* peve TWIPSy do mm */
                                              /* 1" = 72pt, 1" = 25.4 mm */

/* speciln znaky ASCI tabulky */
/********************************/
#define PROCENTO  '%'
#define LSLOZENA  '{'
#define PSLOZENA  '}'
#define BACKSLASH '\\'
#define HASH      '#'
#define HVEZDICKA  '*'
#define ZAVINAC    '@'
#define DOLAR      '$'
#define STRISKA    '^'
#define APERSAND  '&'
#define LZAVORKA  '('
#define PZAVORKA  ')'
#define MINUS      '-'
#define PODTRZENI  '_'
#define PLUS      '+'
#define ROVNITKO  '='
#define LHRANATA  '['
#define PHRANATA  ']'
#define SVISLA    '|'
#define DVOJTECKA  ':'
#define  STREDNIK  ';'
#define UVOZOVKY  '"'
#define APOSTROF  '\''
#define TECKA      '.'
#define CARKA      ','
#define MENSI      '<'
#define VETSI      '>'
#define OTAZNIK    '?'
#define LOMITKO   '/'
#define VLNKA      '~'
#define OAPOSTROF  '`'
#define VYKRICNIK  '!'
#define MEZERA    ' '

/* speciln etzce */
/*********************/
#define SPROCENTO  "%"
#define SLSLOZENA  "{"
#define SPSLOZENA  "}"
#define SBACKSLASH "\\"
#define SHASH      "#"
#define SHVEZDICKA "*"
#define SZAVINAC   "@"
#define SDOLAR     "$"
#define SSTRISKA   "^"
#define SAPERSAND  "&"
#define SLZAVORKA  "("
#define SPZAVORKA  ")"
#define SMINUS     "-"
#define SPODTRZENI "_"
#define SPLUS      "+"
#define SROVNITKO  "="
#define SLHRANATA  "["
#define SPHRANATA  "]"
#define SSVISLA    "|"
#define SDVOJTECKA ":"
#define SSTREDNIK  ";"
#define SUVOZOVKY  "\""
#define SAPOSTROF  "'"
#define STECKA     "."
#define SCARKA     ","
#define SMENSI     "<"
#define SVETSI     ">"
#define SOTAZNIK   "?"
#define SLOMITKO   "/"
#define SVLNKA     "~"
#define SOAPOSTROF "`"
#define SVYKRICNIK "!"
#define SMEZERA    " "

#define SDVADOLARY "$$"
#define SPROCENTOMEZERA  "% "

#define RBACKSLASH       "\\backslash"
#define SUVODNITEXT1    "soubor byl vygenerovn programem:"
#define SUVODNITEXT2    "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
#define SBEGINDOCUMENT  "\\begin{document}\r\r"
#define SENDDOCUMENT     "\\end{document}"
#define SSIRKA          "\\textwidth "
#define SVYSKA          "\\textheight "
#define SODDSIDEMARGIN  "\\oddsidemargin "
#define SEVENSIDEMARGIN  "\\evensidemargin "
#define SFONTYJEDNA     "% definice fontu pouitch v souboru\r"
#define SFONTYDVE        "% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\r"
#define SPREAMBULE      "%%%%%%%%%%%%%%%%%%%%%%%%%%%% preambule %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
#define SKONECPREAMBULE  "%%%%%%%%%%%%%%%%%%%%%%%%% konec preambule %%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
#define SKONECSOUBORU    "%%%%%%%%%%%%%%%%%%%%%%%%%% konec souboru %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
#define SDEF            "\\def"
#define SEQUATION        "Equation"

/************************* pointery na funkce *******************************/
typedef void (*P_FVOID)();  /* pointer na fci vracejc void - pro tabulku
                                funkc pޒkaz RTF */

/* texty pro soubor s parametry */
/********************************/

#define SVDH     "vypis defaultnich hodnot"
#define SVTCAZ  "vypis textu cteni a zapisu"
#define SPMV    "preklad matematickych vzorecku"
#define SDR      "delka radku"
#define SMDR    "maximalni delka radku"
#define SZV      "zakladni velikost"
#define SPF      "prepinac fontu"
#define SPPMV    "pocatecni pozice matematickeho vzorecku"
#define SUMV    "uvozeni matematickeho vzorecku"
#define SMDMV    "maximalni delka matematickeho vzorecku"
#define  SMDPVMV  "maximalni delka parametru v matematickem vzorecku"
#define  SUF      "ukladat fonty"
#define  SUV      "ukladat velikosti"
#define  SVP      "vykonavat prikazy"
#define  SURPZV  "ukladat rezy po zmene velikosti"

#define SPP      "parametry programu"
#define SPD      "preambule dokumentu"
#define SSVF    "substituce velikosti fontu"
#define SSRF    "substituce rodin fontu"
#define SRP      "rtf prikazy"
#define STF      "tabulka fontu"

#endif
/*************************** konec souboru **********************************/
