/*
 * 14. bezna 1996
 *****************
 */

/*
 * cvr_mat.c          verze 1
 *
 * funkce pro peklad RTF matematiky
 * - verze pro Turbo C 2.0
 *
 * (c) Pavel RAK, 1996.01.07 14:25 vznik souboru
 *
 * soubor nelze it bez svolen autora
 *
 */

/**************************** INCLUDE st **********************************/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

/* poad nsledujcch include je ZVAZN */
/*******************************************/
#include "stddef.h"    /* zkladn definice k C, BOOLEAN ... */
#include "cvr_def.h"  /* definice specifick pro program CVREK */
#include "cvr_mat.h"  /* svj vlastn hlavikov soubor */
#include "cvr_hla.h"  /* hlavikov soubor hlavn sti programu */
#include "cvr_rtf.h"  /* hlavikov soubor pekladae RTF */

/************************* IMPORTovan objetky ******************************/
/* testovan vpisn vlajky */
/*****************************/
EXPORT BOOLEAN testa;
EXPORT BOOLEAN testb;
EXPORT BOOLEAN testd;
EXPORT BOOLEAN teste;
EXPORT BOOLEAN testf;
EXPORT BOOLEAN testh;
EXPORT BOOLEAN testi;
EXPORT BOOLEAN testk;
EXPORT BOOLEAN testm;
EXPORT BOOLEAN testt;
EXPORT BOOLEAN testv;
EXPORT BOOLEAN testz;
EXPORT FILE *fc;
EXPORT char sp[];
EXPORT long int novapamet;
EXPORT long int uvolnipamet;

/************************** GLOBALn promnn *******************************/
GLOBAL char mats[3];  /* etzec pro natan hexa znaky v matem. vzorci */
GLOBAL BOOLEAN ukoncit_mat = FALSE;  /* vlajka, zda ukonit ten mat. vzoreku */
GLOBAL int mati = 0;  /* peveden hex etzec do sla */
GLOBAL BOOLEAN vmatici = FALSE;  /* vlajka zda zpracovv matici */
GLOBAL int POCATEKVZORCE;    /* od kter pozice lze oekvat zatek vzoreku */
GLOBAL int ZACATEKVZORCE;    /* kd znaku, kter uvozuje vzoreek (0x0a) */
GLOBAL int MAXDELKAVZORCE;  /* maximln dlka matematickho vzoreku */
GLOBAL int MAXDELKAPARAM;    /* maximln dlka matematickho parametru */

/**************************** lokln define ********************************/

/****************************** lokln typy ********************************/

/**************************** lokln promnn ******************************/
LOCAL BOOLEAN inicializace_mat = FALSE; /* vlajka nauen matem. pޒkaz */
LOCAL int pocet_vzorcu = 0;  /* poitadlo vzorek */
LOCAL  char radek_a[MAXIMALNIDELKARADKU];  /* pracovn އdek jedna */
LOCAL  char radek_b[MAXIMALNIDELKARADKU];  /* pracovn އdek dva */
LOCAL  int delka_a = 0;                    /* pozice znaku v radek_a */
LOCAL  int delka_b = 0;                    /* pozice znaku v radek_b */

LOCAL P_MPR p_smpr = NULL;                /* hlavn pointer na seznam matematickch pޒkaz */
LOCAL int vstupne = 0;      /* poitadlo vstup do funkce parametr */

/***************** pln funkn prototypy globlnch funkc ****************/
GLOBAL void preloz_vzorec(void);

/***************** pln funkn prototypy loklnch funkc *****************/
LOCAL void parametr(char *p_par);
LOCAL void dalsi_mat_znak(void);
LOCAL void vypis_mpr(P_MPR p_koren);
LOCAL P_MPR existuje_mat(P_MPR p_koren, int cislo, long int kod);
LOCAL void prepis(char *p_cil, char *p_text, char *p_pole[]);
LOCAL void pridej_znak(char *p_text, int x, long int y);
LOCAL void genmatpar(char *p_cil, int x, int y);

/************************ definice GLOBALnch funkc ************************/

GLOBAL void preloz_vzorec(void)
/******************************
 * peveden matematickho vzoreku
 *
 * vstup:  nic
 *
 * vstup: dn
 *         do vstupnho souboru se ulo vzoreek v MAT mdu
 */
{
  char *vzorecek;  /* pracovn etzec pro uloen vslednho vzoreku */
  int i = 0;  /* pomocn promnn cylku */

  vzorecek = (char *) nova_pamet(MAXDELKAVZORCE);

  ++pocet_vzorcu;
  ukoncit_mat = FALSE;
  mati = 0;

  if ((testi == TRUE) && (testz == TRUE) && (testf == TRUE)) {
    sprintf(vzorecek, "Zpracovvm matematick vzorec slo %d.", pocet_vzorcu);
    TNO(vzorecek);
  }

  vzorecek[0] = '\0';

  if (inicializace_mat == FALSE) {
    /* CH("Musis se naucit matematick pޒkazy.");*/
    naucit_mat_prikazy(&p_smpr);
    inicializace_mat = TRUE;

    /* testovn na sprvnost nauen pޒkaz (jako u rtf) */

    if (p_smpr == NULL) {
      chyba(CHYBAMATINICIALIZACE);
    }

    if (testt == TRUE) {
      vypis_mpr(p_smpr);
    }
  }

  /* pesko poten znaky a najdi mi skuten zatek dat vzoreku */
  /********************************************************************/

  for (i = 0; i < POCATEKVZORCE; i++) {
    dalsi_mat_znak();
    if (ukoncit_mat == TRUE) {  /* kdy bude chyba, tak se vra */
      return;
    }
  }

  while (mati == ZACATEKVZORCE) {  /* pesko nuly pedchzejc znaku 0a */
    dalsi_mat_znak();              /* kter uvozuje vzoreek */
  }

  vstupne = 0;

  /* zpracovn vzoreku */
  /***********************/
  parametr(vzorecek);

  /* uloen vypracovanho vzoreku do vstupu */
  /*********************************************/
  if (strlen(vzorecek) != 0) {
    uloz_mat(vzorecek);
  }

}

/************************* definice LOCALnch funkc ************************/

LOCAL void parametr(char *p_par)
/*******************************
 * - zpracovn parametru matematickho vzorce
 * - REKURZVN FUNKCE!!!, snadn monost peteen zsobnku
 *
 * vstup:  pointer na alokovan msto pro uloen textu parametru
 *
 * vstup: text v p_par
 *
 * poznmky: - pi klasickm zpracovn textu a symbol nen nutno alokovat msto
 *              velk mnostv parametr, protoe se jenom kopruje text do param
 *           - ale pi zpracovn matic a 03 kdu JE NUTNO alokovat msto pro
 *              vechny mon parametry, v PRACPAR je poet parametr, kter
 *              se alokuje pi vstupu do 03 kdu, slo je zjitno exprimentln
 *              vce parametr jsem u 03 funkce nenalezl
 *           - u matic vstoup do hry MAXPRACPAR, kterm se uruje, jak velk
 *              matice jsem schopen zpracovvat, souin rozmr mus bt men
 *              ne MAXPRACPAR, mon se to d do parametr programu
 *           - tato alotrie s alokac za bhu je nutn z toho dvodu, e pi
 *              statick alokaci se bere msto ze zsobnku, pi dynamick
 *              se spotebovv msto z heapu, kde je ho podstan vce
 *           - pi kadm vstupu do funkce se zv poitadlo vstupne, pi KADM
 *              oputn MUS BT POITADLO vstupne SNENO o jedna; je to proto,
 *              aby pi zpracovn na nult urovni a naten 00 se fce nevracela
 *              i kdy by mohly bt njak dal znaky (mon se od tohoto upust,
 *              uvidm, jak mi to bude fungovat)
 */
{
  BOOLEAN cist = TRUE;    /* vlajka, zda st dal znak z textu vzoreku */
  BOOLEAN konec = FALSE;  /* vlajka, zda ji m ukonit zpracovn parametru */
  P_MPR p_mpar;            /* pomocn pointer na strukturu vyhledanho pޒkazu */
  char *param;  /* odkldac prostor pro JEDEN zpracovvan
                                  parametr */
  char *p_spar[MAXPRACPAR];            /* pole pro parametry etzc */
  int parametru = 0;                  /* poet parametr u 03 kd */
  long int h = 0;      /* pracovn prom. pro vpoet hodnoty u kd 02 */

  if (ukoncit_mat == TRUE) {  /* mm-li ji skonit, tak se hned vra a dle
                                  ji nic nezpracovvej */
    return;
  }

  param = (char *) nova_pamet(MAXDELKAPARAM);

  {  /* nulovn pointer na parametry */
    int i;

    for (i = 0; i < MAXPRACPAR; i++) {
      p_spar[i] = NULL;
    }
  }

  ++vstupne;
  delka_a = delka_b = 0;    /* vynuluj pracovn etzce */
  radek_a[delka_a] = '\0';
  radek_b[delka_b] = '\0';

  param[0] = '\0';    /* nuluj etzec (pro jistotu) */

  /*** hlavn smyka dekdovn vzoreku ***/
  /*****************************************/

  while (konec == FALSE) {

    if (cist == TRUE) {    /* naten dalho znaku z textu vzoreku */
      dalsi_mat_znak();
      cist = TRUE;
      if (ukoncit_mat == TRUE) {  /* je-li na konci textu i zvorce }, tak se vra */
        uvolni_pamet(param);
        return;
      }
    }
    else {
      cist = TRUE;
    }


    if (mati == 0x12) {
      dalsi_mat_znak();
      h = 256l * mati;
      if (mati == 0x82) {
        strcat(param, SBACKSLASH);
        h = 256l * 0x83;
      }
      else {
        dalsi_mat_znak();
        h = h + mati;
        pridej_znak(param, 2, h);  /* vyuvm tabulky 02 83 */
        continue;
      }
      dalsi_mat_znak();
      h = h + mati;
      pridej_znak(param, 2, h);

      dalsi_mat_znak();

      while (mati == 0x12) {
        dalsi_mat_znak();
        if (mati == 0x82) {
          h = 256l * 0x83;
          dalsi_mat_znak();
          h = h + mati;
          pridej_znak(param, 2, h);
          dalsi_mat_znak();
        }
        else {
          strcat(param, SMEZERA);
          h = 256l * mati;
          dalsi_mat_znak();
          h = h + mati;
          pridej_znak(param, 2, h);
          break;
        }
      }
      strcat(param, SMEZERA);
    }

  switch (mati) {

      case 0: if (vstupne > 1) {
                konec = TRUE;
              }
              else {
                if (strlen(param) != 0) {
                  uloz_mat(param);
                  novy_radek();
                  novy_radek();
                }
                param[0] = '\0';
              }

              /* konec = TRUE; */
              break;

      case 1:  break;

      case 2:  dalsi_mat_znak();
              h = 256l * mati;
              dalsi_mat_znak();
              h = h + mati;
              pridej_znak(param, 2, h);
              break;

      case 3:  dalsi_mat_znak();
              h = mati * 65536l;
              dalsi_mat_znak();
              h = h + mati * 256l;
              dalsi_mat_znak();
              h = h + (long int) mati;
              if ((p_mpar = existuje_mat(p_smpr, 3, h)) == NULL) {
                if ((testi == TRUE) && (testz == TRUE)) {
                  sprintf(sp, "Pޒkaz 03 %06lx nen definovn v tabulce pޒkaz!", h);
                  PRINT
                }
                /* CH(sp); */
              }
              else {
                int o;  /* promnn cyklu */

                parametru = p_mpar->parametru;
                if ((testi == TRUE) && (testz == TRUE) && (teste == TRUE)) {
                  sprintf(sp, "Zpracovvm pޒkaz 03 %06lx s %d parametry.", h, parametru);
                }

                if (testa == TRUE) {
                  PRINT
                }

                /* CH(sp); */

                if (vmatici == TRUE) {  /* jsi-li v matici, tak nezpracovvej
                                            posledn nulu */
                  --parametru;
                }
                /*else {
                	if (vstupne > 2) {
       		           --parametru;
                	}
                }*/

                for (o = 1; o <= parametru; o++) {
                  p_spar[o] = (char *) nova_pamet(sizeof(char) * MAXDELKAPARAM);
                  *p_spar[o] = '\0';

                  parametr(p_spar[o]);
                }

                prepis(param, p_mpar->p_pred, p_spar);

                for (o = 1; o <= parametru; o++) {
                  uvolni_pamet(p_spar[o]);
                  p_spar[o] = NULL;
                }
              }
              break;

      case 4: break;

      case 5:  dalsi_mat_znak();
              if (mati == 0) {
                konec = TRUE;
              }
              else {
                h = mati;
                dalsi_mat_znak();
                h = h + mati;
                dalsi_mat_znak();
                h = h + mati;
                if (h != 3) {
                  if ((testi == TRUE) && (testz == TRUE)) {
                    sprintf(sp, "Pޒkaz 05 neuvozuje matici. Je mon vskyt chyb.");
                  }
                  /* CH(sp); */
                  PRINT
                  konec = TRUE;
                  /* exit(-1); */
                  continue;
                }
                else {
                  int radek;          /* poet އdk matice */
                  int sloupcu;        /* poet sloupc matice */
                  char **p_p_pmatice;  /* pointer na pole pointer parametr matice */
                  char *p_prepis;
                  int i;
                  int j;

                  dalsi_mat_znak();
                  radek = mati;
                  dalsi_mat_znak();
                  sloupcu = mati;

                  dalsi_mat_znak();    /* peskoen bezvznamnch null */
                  while (mati == 0) {
                    dalsi_mat_znak();
                  }

                  p_prepis = (char *) nova_pamet(MAXDELKAVZORCE * sizeof(char) + 1);
                  p_prepis[0] = '\0';
                  p_p_pmatice = (char **) nova_pamet(sizeof(char*) * radek * sloupcu);

                  if ((testi == TRUE) && (testz == TRUE) && (teste == TRUE)) {
                    sprintf(sp, "Zpracovvm matici rozmr %d krat %d.", radek, sloupcu);
                  }
                  if (testa == TRUE) {
                    PRINT
                  }
                  /* CH(sp); */
                  genmatpar(p_prepis, radek, sloupcu);

                  vmatici = TRUE;

                  for (i = 0; i < radek; i++) {
                    for (j = 0; j < sloupcu; j++) {
                      p_p_pmatice[1 + i * sloupcu + j] = (char *) nova_pamet(sizeof(char) * MAXDELKAPARAM);
                      p_p_pmatice[1 + i * sloupcu + j][0] = '\0';
                      parametr(p_p_pmatice[1 + i * sloupcu + j]);
                    }
                  }

                  vmatici = FALSE;

                  prepis(param, p_prepis, p_p_pmatice);

                  if (vstupne <= 1) {
                    dalsi_mat_znak();
                  }

                  for (i = 0; i < radek; i++) {
                    for (j = 0; j < sloupcu; j++) {
                      uvolni_pamet(p_p_pmatice[1 + i * sloupcu + j]);
                    }
                  }

                  uvolni_pamet(p_p_pmatice);
                  uvolni_pamet(p_prepis);
                }
              }
              break;

      case 0x08:  dalsi_mat_znak();
                  dalsi_mat_znak();
                  dalsi_mat_znak();
                  while (mati != 0) {
                    dalsi_mat_znak();
                  }
                  break;

      case 0x09:  dalsi_mat_znak();
                  dalsi_mat_znak();
                  break;

      case 0x32:  dalsi_mat_znak();
                  if (mati != 0x83) {
                    if ((testi == TRUE) && (testz == TRUE)) {
                      sprintf(sp, "Nesprvn pouit pޒkazu #32.");
                      PRINT
                    }
                    continue;
                  }
                  dalsi_mat_znak();
                  h = mati;
                  dalsi_mat_znak();
                  if (mati != 0x06) {
                    if ((testi == TRUE) && (testz == TRUE)) {
                      sprintf(sp, "Nesprvn pouit pޒkazu 06.");
                      PRINT
                    }
                  }
                  dalsi_mat_znak();
                  if ((p_mpar = existuje_mat(p_smpr, 6, mati)) == NULL) {
                    if ((testi == TRUE) && (testz == TRUE) ) {
                      sprintf(sp, "Pޒkaz 06 %d nen implemetnovn.", mati);
                      PRINT
                    }
                  }
                  dalsi_mat_znak();
                  dalsi_mat_znak();
                  if (p_mpar == NULL) {
                    continue;
                  }
                  if (p_mpar->p_pred != NULL) {
                    strcat(param, p_mpar->p_pred);
                  }

                  {
                    char sp[3];
                    sp[0] = h;
                    sp[1] = '\0';
                    strcat(param, sp);
                  }

                  if (p_mpar->p_po != NULL) {
                    strcat(param, p_mpar->p_po);
                  }
                  strcat(param, SMEZERA);
                  break;

      default:  break;  /* ty co neche znt, tak normln ignoruj */

    }
  }

  /************ konen fze funkce ******************/
  /*  CH("Ukldm tento text:");*/
  /*  CH(param); */
  /***************************************************/

  if (strlen(param) != 0) {    /* kdy je parametr neprzdn, ulo jej do vstupu */
    if (strlen(p_par) != 0)  {
      strcat(p_par, param);
    }
    else {
      strcpy(p_par, param);
    }
  }

  --vstupne;            /* sni poitadlo vstup do funkce */
  uvolni_pamet(param);  /* uvoln pam zabranou pro parametr */
  return;
}

LOCAL void pridej_znak(char *p_text, int x, long int y)
/******************************************************
 * pid do vstupu text pޒkazu slo x a kdu y, nap. 12 41 ulo A
 *
 * vstup:  x - slo pޒkazu
 *         y - kd pޒkazu
 *
 * vstup: do p_text ulo bu text, kter pete z p_pred u pޒkazu, nebo
 *          nco ohls do CVR souboru
 *
 */
{
  P_MPR p_matpar = NULL;

  if ((p_matpar = existuje_mat(p_smpr, x, y)) == NULL) {
    if ((testi == TRUE) && (testz == TRUE)) {
      sprintf(sp, "Pޒkaz slo %02d s kdem %06lx neexistuje.", x, (long) y);
      PRINT
    }
  }
  else {
    if ((p_matpar != NULL) || (strlen(p_matpar->p_pred) != 0)) {
      strcat(p_text, p_matpar->p_pred);
    }
  }
}

LOCAL void dalsi_mat_znak(void)
/******************************
 * - nate dva znaky ze vstupu a pelo hexa etzec do celho sla
 * - naten znaky ulo do etzce mats
 * - provd se konverze na mal psmena
 *
 * vstup:  dn
 *
 * vstup: nepޒmo se do globln prom. mati ulo slo reprezent. hexa hodnotu
 *         kdy naraz na nehexa nebo nemezerov znak, tak nastav vlajku
 *          ukonci_mat na TRUE
 *
 */
{
  int i = 0;          /* prvn slice */
  int j = 0;          /* druh slice */

  mati = -1;
  mats[0] = '\0';

  /* prvn psmeno */
  /*****************/
  i = tolower(dalsi_znak());

  while (i == MEZERA) {  /* dalsi_znak mi pi ascii < 32 vrt 32 */
    i = tolower(dalsi_znak());
  }

  if ( (i < '0') || i > '9') {      /* testuj na hexa znaky */
    if ((i < 'a') || (i > 'f')) {
      ukoncit_mat = TRUE;
      return;
    }
  }

  j = i;

  /* druh psmeno */
  /*****************/
  i = tolower(dalsi_znak());

  while (i == MEZERA) {  /* dalsi_znak mi pi ascii < 32 vrt 32 */
    i = tolower(dalsi_znak());
  }

  if ( (i < '0') || i > '9') {      /* testuj na hexa znaky */
    if ((i < 'a') || (i > 'f')) {
      ukoncit_mat = TRUE;
      preskoc_skupinu();
      return;
    }
  }

  mats[0] = j;
  mats[1] = i;
  mats[2] = '\0';

  /* pevod z hexa etzce do intu */
  /*********************************/

  if (isalpha(j) != NULL) {
    mati = j - 'a' + 10;
  }
  else {
    mati = j - '0';
  }

  mati *= 16;

  if (isalpha(i) != NULL) {
    mati += (i - 'a' + 10);
  }
  else {
    mati += (i - '0');
  }

  return;
}

LOCAL void vypis_mpr(P_MPR p_koren)
/**********************************
 * vype seznam nauench matematickch pޒkaz
 *
 * vstup:  pointer na tabulku pޒkaz
 *
 * vstup: nco ti zobraz do cvr souboru
 *
 */
{
  while (p_koren != NULL) {
    sprintf(sp, "%02x %06lx - %d (%d:%ld)", p_koren->cislo, p_koren->kod, p_koren->parametru, p_koren->cislo, p_koren->kod);
/*    CH(sp);*/
    PRINT
    sprintf(sp, "\t'%s' '%s' '%s'", p_koren->p_pred, p_koren->p_stred, p_koren->p_po);
    PRINT
/*  CH(sp);*/
    p_koren = p_koren->p_dalsi;
  }
}

LOCAL P_MPR existuje_mat(P_MPR p_koren, int cislo, long int kod)
/***************************************************************
 * vyhledn matematickho pޒkazu v tabulce
 *
 * vstup:  pointer na tabulku P_MPR
 *         slo pޒkazu (int)
 *         kd pޒkazu (long)
 *
 * vstup: NULL, kdy neexistuje
 *         pointer na strukturu jinak
 */
{
  while (p_koren != NULL) {
    if ((p_koren->cislo == cislo) && (p_koren->kod == kod)) {
      return(p_koren);
    }
    p_koren = p_koren->p_dalsi;
  }
  return(NULL);
}

LOCAL void prepis(char *p_cil, char *p_text, char *p_pole[])
/***********************************************************
 * pepsn etzce a parametr do vstupnho etzce
 *
 * vstup:  clov etzec
 *         text pro pepis
 *         pole pointer na parametry
 *
 * vstup: do clovho etezce budou koprovnvy znaky z textu pro pepis
 *          a posloupnosti #1, #2 apod. budou nahrazovny texty z parametr
 *
 * poznmka: je-li teba nkter znak uloit bez interpretace, nech jej uvod
 *            backslashem, POZOR! PLAT TO POUZE PRO JEDEN ZNAK!!!
 */
#define DAL {c = *(p_text + j++); }
{
  int delka = strlen(p_text);  /* zjisti si dlku textu pro pepis */
  int j = 0;  /* poitadlo cyklu */
  int c = 0;  /* pracovn prom. */
  char scp[2];
  int cispar;  /* slo parametru */

  scp[0] = MEZERA;
  scp[1] = '\0';

  DAL
  while (j <= delka) {

    switch (c) {

      case HASH:  cispar = 0;
                  DAL
                  while (isdigit(c) != FALSE) {
                    cispar = 10 * cispar + c - '0';
                    DAL
                  }
                  /* --cispar; */
                  if (p_pole[cispar] != NULL) {
                    strcat(p_cil, p_pole[cispar]);
                  }
                  continue;
                  /* break; */


      case BACKSLASH: scp[0] = BACKSLASH;
                      strcat(p_cil, scp);
                      DAL
                      scp[0] = c;
                      strcat(p_cil, scp);
                      break;

      default:   scp[0] = c;
                strcat(p_cil, scp);
                break;
    }

    DAL
  }

  return;
}

LOCAL void genmatpar(char *p_cil, int x, int y)
/**********************************************
 * generuje pepisovac text k uloen matice
 *
 * vstup:  kam ukldat
 *         poet އdk
 *         poet sloupc
 *
 * vstup: do p_cil ulo text k zpracovn fc pepis
 */
{
  int i = 0;
  int j = 0;
  P_MPR p_mpar = NULL;
  char *pom;

  pom = (char *) nova_pamet(300 * sizeof(char));

  if ((p_mpar = existuje_mat(p_smpr, 5, 0)) == NULL) {
    TNO("Pޒkaz matice nen definovn. Matice nebude zpracovna.");
    return;
  }

  strcpy(p_cil, p_mpar->p_pred);

  for (i = 0; i < x; i++) {
    for (j = 0; j < y; j++) {
      if (j == (y -1)) {
        sprintf(pom, " #%d ", 1 + i * y + j );
      }
      else {
        sprintf(pom, " #%d & ", 1 + i * y + j );
      }
      strcat(p_cil, pom);
    }
    if (i < (x-1)) {
      strcat(p_cil, p_mpar->p_stred);
    }
  }

  strcat(p_cil, p_mpar->p_po);
}
/*************************** konec souboru **********************************/
