/*
 * 14. bezna 1996
 *****************
 */

/*
 * cvr_hla.c					verze 1
 *
 * hlavn soubor projektu CVREK
 * -----------------------------
 * - verze pro Turbo C 2.0
 * - jmno spustitelnho souboru CVR.EXE na PC, CVREK na Macintoshi
 *
 * (c) Pavel RAK, 1996.01.07 14:25 vznik souboru
 *
 * soubor nelze it bez svolen autora
 *
 */

/**************************** INCLUDE st **********************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>
#include <conio.h>
#include <ctype.h>

/* poad nsledujcch include je ZVAZN */
/*******************************************/
#include "stddef.h"		/* zkladn definice k C, BOOLEAN ... */
#include "cvr_def.h"  /* definice specifick pro program CVREK */
#include "cvr_hla.h"  /* svj vlastn hlavikov soubor */
#include "cvr_rtf.h"  /* hlavikov soubor pekladae RTF */
#include "cvr_mat.h"  /* hlavikov soubor pekladae vzorek */

/************************* IMPORTovan objetky ******************************/

/* rtf */
/*******/
EXPORT BOOLEAN ukoncit;	/* zda se m peklad ukonit, pouije v dalsi_znak() */
EXPORT long int znaku;	/* pomocn poitadlo skuten natench znak */
EXPORT int c;
EXPORT int d;
EXPORT int velikostpt;	/* standardn velikost psma dokumentu v pt */
EXPORT char FONTPREPINAC[];	/* posloupnost pro text pepnn font */
EXPORT int POCATEKVZORCE;		/* od kter pozice lze oekvat zatek vzoreku */
EXPORT int ZACATEKVZORCE;		/* kd znaku, kter uvozuje vzoreek (0x0a) */
EXPORT int MAXDELKAVZORCE;	/* maximln dlka matematickho vzoreku */
EXPORT int MAXDELKAPARAM;		/* maximln dlka matematickho parametru */

/* matematika */
/**************/
EXPORT char mats[3];	/* etzec pro natan hexa znaky v matem. vzorci */
EXPORT BOOLEAN ukoncit_mat;	/* vlajka, zda ukonit ten mat. vzoreku */
EXPORT int mati;	/* peveden hex etzec do sla */

/* vlajky z cvr_rtf*/
/*******************/
EXPORT BOOLEAN ukladat_font;			/* vlajka, zda ukldat definice font a
																			akceptovat pepnn font */
EXPORT BOOLEAN ukladat_velikosti;	/* vlajka, zda ukldat velikosti font */
EXPORT BOOLEAN vykonavat_prikazy;	/* vlajka, zda vbec pekldat pkazy */
EXPORT BOOLEAN ukladat_rezy;			/* vlajka, zda ukldat \bold a \italic */

/************************** GLOBALn promnn *******************************/
/* testovac promnn */
/**********************/
GLOBAL BOOLEAN testa = FALSE;	/* zprvy pi zpracovn matematickch pkaz */
GLOBAL BOOLEAN testb = FALSE;	/* vpis tabulek definovanch font */
GLOBAL BOOLEAN testd = FALSE;	/* vpis defaultnho nastaven */
GLOBAL BOOLEAN teste = TRUE;	/* vpisy pi zpracovn vzoreku */
GLOBAL BOOLEAN testf = FALSE;	/* vpisy ve funkcch */
GLOBAL BOOLEAN testh = FALSE;	/* vstupy v cvr_hla.c, nedokumentovat a nenanstavovat!!! */
GLOBAL BOOLEAN testi = FALSE;	/* hlen vstupu vstupu */
GLOBAL BOOLEAN testk = FALSE;	/* kdovac tabulky font - naten ze zdroj */
GLOBAL BOOLEAN testm = FALSE;	/* operace s pamt */
GLOBAL BOOLEAN testt = FALSE;	/* vpis matematickch pkaz */
GLOBAL BOOLEAN testv = FALSE;	/* vstupy pkaz, nauench pkaz */
GLOBAL BOOLEAN testz = TRUE;	/* pekldat vzoreky? */
GLOBAL FILE *fc;							/* zprva o pekladu */
GLOBAL FILE *fm;							/* soubor s pkazy, parametry */
GLOBAL char sp[250];					/* pomocn etzec pro ukldn printf text */
GLOBAL int DELKARADKU = 65;		/* dlka jednoho dku na vstupu */
GLOBAL int MAXDELKARADKU = 75;	/* maximln dlka dku, kdy se skuten zalom */

/**************************** lokln define ********************************/

#define UPRAV(x,y) {font1.tab_znak[(x)].mod = NEZAVISLY; font1.tab_znak[(x)].delka = 0; font1.tab_znak[(x)].ascii = MEZERA; font1.tab_znak[(x)].p_texposl = y;}
#define MATUPRAV(x,y) {font1.tab_znak[(x)].mod = MAT; font1.tab_znak[(x)].delka = 0; font1.tab_znak[(x)].ascii = MEZERA; font1.tab_znak[(x)].p_texposl = y;}

#define UPRAVIT(x,y) {p_prac->tab_znak[(x)].delka = 0; p_prac->tab_znak[(x)].p_texposl = (char *) nova_pamet(sizeof(char) * strlen((y)) + 1); strcpy(p_prac->tab_znak[(x)].p_texposl, (y));}
#define MATUPRAVIT(x,y) {p_prac->tab_znak[(x)].delka = 0; p_prac->tab_znak[(x)].mod = MAT; p_prac->tab_znak[(x)].p_texposl = (char *) nova_pamet(sizeof(char) * strlen((y)) + 1); strcpy(p_prac->tab_znak[(x)].p_texposl, (y));}
#define DALSI	{if (c == EOF) { break; } else {c = getc(fm);}}

/****************************** lokln typy ********************************/

/**************************** lokln promnn ******************************/
LOCAL char *p_verze_autor = "CVREK verze 1 Copyright (c) 1996 Pavel RAK";
LOCAL char *p_verze_zpusob = "*** pouit programu je vhradn"
														 " na vae vlastn riziko";

LOCAL FILE *fr,				/* vstupn soubor (RTF formt) */
					 *fw;				/* vstupn soubor (LaTeXov formt) */

LOCAL MODUKLADANI mod_ukladani = TEXT;	/* zpsob zpisu do vstupnho souboru */

LOCAL char vyst_bafr[DELKABAFRU + 1];	/* pracovn bafr pro vstupn soubor */
LOCAL long int celkem = 0;						/* kolik pamti se od systmu alokovalo */
LOCAL char cesta[128];	/* aktuln cesta k exe souboru CVREK */
LOCAL char tempcesta[128];	/* pracovn cesta */
LOCAL FONTSUBST rodina[TECH + 1];		/* substituce rodin font */
LOCAL PREAMBULE pre1[10];						/* dky preambule */
LOCAL VELFONTU vf[20];							/* tabulka velikosti font */
LOCAL P_FONT p_font1;								/* hlavn pointer na font */
LOCAL P_FONT p_font2;								/* pracovn pointer na font */
LOCAL BOOLEAN	ini = FALSE;					/* nateny parametry hned po startu */
LOCAL int fontporadi = 0;						/* poad natenho fontu */

/***************  pln funkn prototypy globlnch funkc *****************/

GLOBAL void chyba(KODCHYBY m);
GLOBAL int dalsi_znak(void);
GLOBAL void uloz_nezav_text(const char *p_text);
GLOBAL void uloz_text(const char *p_text);
GLOBAL void uloz_mat(const char *p_text);
GLOBAL void uloz_mat_symbol(const char *p_text);
GLOBAL void uloz_mat_mat(const char *p_text);
GLOBAL void uloz_poznamky(const char *p_text);
GLOBAL void novy_radek(void);
GLOBAL void uloz_znak(int c);
GLOBAL void *nova_pamet(long int velikost);
GLOBAL void *uvolni_pamet(void *p_void);
GLOBAL void naucit_prikazy(P_RPR *p_p_rpr, 						/* int *p_pocet_rpr, */
													 P_FONTSUBST *p_p_subrf,
													 P_PREAMBULE *p_p_preambule,
													 P_VELFONTU *p_p_velfontu,
													 P_FONT *p_p_font);
/* GLOBAL void nastav_parametry(void); */
GLOBAL void naucit_mat_prikazy(P_MPR *p_p_matpr);

/***************  pln funkn prototypy loklnch funkc ******************/

LOCAL void uloz_retezec(const char *p_s, MODUKLADANI mod);
LOCAL void zalomeni(int *p_pozice, int *p_pozice_mezery);
LOCAL void zkraceni(int *p_pozice, int *p_pozice_mezery);
LOCAL void nalej(char *p_cil);
LOCAL void nalej_spec(char *p_cil);

/****************************** funkce main() *******************************/

/* MACintosh */
/*************/
#if MAC
/******/
void main(void)			/* hlavika na MACovi */
{
	char s_vstup[250],		/* jmno vstupnho souboru */
			 s_vystup[250],		/* jmno vstupnho souboru */
			 s_hlaseni[250];	/* jmno souboru s prbhem pekladu */
#endif

/* PC */
/******/
#if PC
/****/
int main(int argv, char *argc[])	/* hlavika na PC */
{
	char s_vstup[13],		/* jmno vstupnho souboru */
			 s_vystup[13],	/* jmno vstupnho souboru */
			 s_hlaseni[13], /* jmno souboru s prbhem pekladu */
			 drive[10];     /* jmno disku */

	/* zskn cesty k exe souboru a uloen do promnn cesta */
	/***********************************************************/
	fnsplit(argc[0], drive, tempcesta, NULL, NULL);
	strcpy(cesta, drive);
	strcat(cesta, tempcesta);

	puts(cesta);
	ini = FALSE;
	naucit_prikazy(NULL, NULL, NULL, NULL, NULL);
	ini = TRUE;

	if (argv == 1) {
		chyba(NENIPRVNIPARAMETR);
		return;
	}

	if (argv > 2) {
		chyba(PRILISMNOHOPARAMETRU);
		return;
	}

	strcpy(s_vstup, argc[1]);

	fnsplit(argc[1], NULL, NULL, s_vystup, NULL);
	strcat(s_vystup, ".tex");

	fnsplit(argc[1], NULL, NULL, s_hlaseni, NULL);
	strcat(s_hlaseni, ".cvr");

	if (testi == TRUE) {
		if ((fc = fopen(s_hlaseni, "w")) == NULL) {
			chyba(NELZEOTEVRIT);
		}
		else {

			if (testi == TRUE) {
				TNO(p_verze_autor);
				TNO(p_verze_zpusob);
				TNO("Ladc informace aktivovny.");
			}

			if (testi == TRUE) {
				TNO("Soubor zprv pekladu se podailo otevt pro zpis.");
			}
		}
	}

	if ((fr = fopen(s_vstup, "r")) == NULL) {
		chyba(NELZEOTEVRIT);
	}
	else {
		if (testi == TRUE) {
			TNO("Vstupn soubor se podailo otevt pro ten.");
		}
	}

	if ((fw = fopen(s_vystup, "w")) == NULL) {
		chyba(NELZEOTEVRIT);
	}
	else {
		if (testi == TRUE) {
			TNO("Vstupn soubor se podailo otevt pro zpis.");
		}
	}

	if (testf == TRUE) {
		TNO("Zpracovn RTF souboru funkc preloz_rtf().");
	}

#endif

/* spolen akce */
/*****************/

	/* uloen informaci o programu a autorovi */
	/*******************************************/
	uloz_poznamky("");
	uloz_poznamky(s_vystup);
	uloz_poznamky("");
	uloz_poznamky(SUVODNITEXT1);
	uloz_poznamky(SUVODNITEXT2);
	uloz_poznamky(p_verze_autor);
	uloz_poznamky("");
	uloz_poznamky(SPREAMBULE);

	preloz_rtf();	/* zavolej si peklad RTF souboru */
	novy_radek();	/* ulo rozpracovan dek */

	uloz_text(SENDDOCUMENT);
	novy_radek();
	uloz_poznamky(SKONECSOUBORU);
	novy_radek();

	if (testm == TRUE) {
		sprintf(sp, "Celkem bylo vydno od systmu %lu bajt.", celkem);
		PRINT
	}

/* konec spolench akc */
/*************************/

/* ukonen na MACINTOSHI */
/**************************/
#if MAC
	}
#endif

/* ukonen na PC */
/******************/
#if PC

	if (fclose(fr) == EOF) {
		chyba(NELZEZAVRIT);
	}
	else {
		if (testi == TRUE) {
			TNO("Vstupn soubor se podailo zavt.");
		}
	}

	if (fclose(fw) == EOF) {
		chyba(NELZEZAVRIT);
	}
	else {
		if (testi == TRUE) {
			TNO("Vstupn soubor se podailo zavt.");
		}
	}

	if (testi == TRUE)	{
		TNO("Uzaven souboru se zprvami o pekladu.");
	}

	if (testi == TRUE) {
		if (fclose(fc) == EOF) {
			chyba(NELZEZAVRIT);
		}
		else {
			TNO("Soubor zprv pekladu se podailo zavt.");
		}
	}

	return;
}
#endif

/************************ definice GLOBALnch funkc ************************/

GLOBAL void chyba(KODCHYBY m)
/****************************
 * vpis chybovho hlen (tmto se chci vyhnout textm chybovch hlen
 * v programu) a nsiln ukonen programu
 *
 * vstup:  kd chyby (KODCHYBY)
 *
 * vstup: text na obrazovce
 *
 */
{
	switch (m) {

		case NELZEOTEVRIT:
			CH("Nelze otevt soubor! Program je pedasn ukonen.");
			exit(NELZEOTEVRIT);
			break;

		case NELZEZAVRIT:
			CH("Nelze zavt soubor! Program je pedasn ukonen.");
			exit(NELZEZAVRIT);
		break;

		case NENIPAMET:
			CH("Nen voln pam؜! Program je pedasn ukonen.");
			exit(NENIPAMET);
			break;

		case CHYBACTENI:
			CH("Chyba pi ten souboru! Program je pedasn ukonen.");
			exit(CHYBACTENI);
			break;

		case CHYBAZAPISU:
			CH("Chyba pi zpisu souboru! Program je pedasn ukonen.");
			exit(CHYBAZAPISU);
			break;

		case NENIPRVNIPARAMETR:
			CH("Nen pedno jmno souboru jako prvn parametr! Program je pedasn ukonen.");
			exit(NENIPRVNIPARAMETR);
			break;

		case PRILISMNOHOPARAMETRU:
			CH("Mnoho parametr, oekvm jeden! Program je pedasn ukonen.");
			exit(PRILISMNOHOPARAMETRU);
			break;

		case CHYBAINICIALIZACE:
			CH("Nastala chyba pi inicializaci programu! Program je pedasn ukonen.");
			exit(CHYBAINICIALIZACE);
			break;

		case CHYBAMATINICIALIZACE:
			CH("Nastala chyba pi inicializaci matematiky! Program je pedasn ukonen.");
			exit(CHYBAINICIALIZACE);
			break;

		case CHYBNYVSTUPNISOUBOR:
			CH("Neukoneny RTF skupiny. Vstupn soubor je pokozen!");
			break;

		case DLOUHYPRIKAZ:
			CH("Naten pli dlouh RTF pkaz. Program je pedasn ukonen!");
			exit(DLOUHYPRIKAZ);

		case NENIRTF:
			CH("Vstupn soubor nen soubor formtu RTF. Program je pedasn ukonen!");
			exit(NENIRTF);

		default:
			CH("Ble nespecifikovateln chyba! Program je pedasn ukonen.");
			exit(DEFAULT);
			break;
	}
}

GLOBAL int dalsi_znak(void)
/**************************
 * ped dal znak z vstupnho souboru
 *
 * vstup:  nic
 *         v LOCAL fr je pointer na oteven vstupn soubor
 *
 * vstup: znak, -1 (EOF) v ppad, e ji dal nen
 *
 */
{
	d = c;

	++znaku;

	if ((c = getc(fr)) == EOF) {
		ukoncit = TRUE;

		if (testi == TRUE) {
			sprintf(sp, ">EOF<");
			PRINT
		}

	}
	else {
		if (c < MEZERA) {		/* potej s variantou, e to bude binrn soubor */
			c = MEZERA;				/* msto znaku novho dku vra znak MEZERA */
		}
	}

	return(c);
}

GLOBAL void uloz_nezav_text(const char *p_text)
/**********************************************
 * uloen etzce "as is", tj. nezle na aktulnm mdu
 * pouv jej rutina na ukldn jednotlivch znak z fontov tabulky, jedn
 * se pedevm o speciln znaky \{, \# apod.
 */
{
	uloz_retezec(p_text, NEZAVISLY);
}

GLOBAL void uloz_text(const char *p_text)
/****************************************
 * uloen textu v textovm mdu, je-li zrovna aktuln jin, tak se
 * do textovho mdu pepni a pak zase ten pvodn obnov
 *
 * vstup:  p_text - pointer na ukldan tzec
 *
 * vstup: dn
 *
 * cl:   do vstupnho souboru zape poadovan etzec
 *
 */
{
	switch (mod_ukladani) {

		case TEXT			: uloz_retezec(p_text, TEXT);
										break;

		case MAT			:	uloz_retezec(SDOLAR, TEXT);
										uloz_retezec(p_text, TEXT);
										uloz_retezec(SDOLAR, TEXT);
										break;

		case MATMAT		:	uloz_retezec(SDVADOLARY, TEXT);
										uloz_retezec(p_text, TEXT);
										uloz_retezec(SDVADOLARY, TEXT);
										break;

		case POZNAMKY	: uloz_retezec(p_text, TEXT);
										break;

		default				: uloz_retezec(p_text, TEXT);
										break;

	}
}

GLOBAL void uloz_mat(const char *p_text)
/***************************************
 * uloen textu v matematickm mdu, je-li zrovna aktuln jin, tak se
 * do matematickho mdu pepni a pak zase ten pvodn obnov
 *
 * vstup:  p_text - pointer na ukldan tzec
 *
 * vstup: dn
 *
 * cl:   do vstupnho souboru zape poadovan etzec
 *
 */
{
	switch (mod_ukladani) {

		case TEXT			: uloz_retezec(SMEZERA, TEXT);
										uloz_retezec(SDOLAR, TEXT);
										uloz_retezec(p_text, TEXT);
										uloz_retezec(SDOLAR, TEXT);
										uloz_retezec(SMEZERA, TEXT);
										break;

		case MAT			:	uloz_retezec(SMEZERA, TEXT);
										uloz_retezec(p_text, TEXT);
										uloz_retezec(SMEZERA, TEXT);
										break;

		case MATMAT		:	uloz_retezec(SDVADOLARY, TEXT);
										uloz_retezec(SMEZERA, TEXT);
										uloz_retezec(SDOLAR, TEXT);
										uloz_retezec(p_text, TEXT);
										uloz_retezec(SDOLAR, TEXT);
                    uloz_retezec(SMEZERA, TEXT);
										uloz_retezec(SDVADOLARY, TEXT);
										break;

		default				: TNO("Nelze uloit, jsi v nevhodnm mdu.");
										break;

	}
}

GLOBAL void uloz_mat_symbol(const char *p_text)
/**********************************************
 * uloen textu v matematickm mdu, je-li zrovna aktuln jin, tak se
 * do matematickho mdu pepni a pak zase ten pvodn obnov
 *
 * verze pro uloen matematickho symbolu, kter neme bt uvozen mezerou
 * ped a za
 *
 * vstup:  p_text - pointer na ukldan tzec
 *
 * vstup: dn
 *
 * cl:   do vstupnho souboru zape poadovan etzec
 *
 */
{
	switch (mod_ukladani) {

		case TEXT			: /* uloz_retezec(SMEZERA, TEXT); */
										uloz_retezec(SDOLAR, TEXT);
										uloz_retezec(p_text, TEXT);
										uloz_retezec(SDOLAR, TEXT);
										/* uloz_retezec(SMEZERA, TEXT); */
										break;

		case MAT			:	/* uloz_retezec(SMEZERA, TEXT); */
										uloz_retezec(p_text, TEXT);
										/* uloz_retezec(SMEZERA, TEXT); */
										break;

		case MATMAT		:	uloz_retezec(SDVADOLARY, TEXT);
										/* uloz_retezec(SMEZERA, TEXT); */
										uloz_retezec(SDOLAR, TEXT);
										uloz_retezec(p_text, TEXT);
										uloz_retezec(SDOLAR, TEXT);
										/* uloz_retezec(SMEZERA, TEXT); */
										uloz_retezec(SDVADOLARY, TEXT);
										break;

		default				: TNO("Nelze uloit, jsi v nevhodnm mdu.");
										break;
	}
}

GLOBAL void uloz_mat_mat(const char *p_text)
/*******************************************
 * uloen textu v dvojmatematickm mdu, je-li zrovna aktuln jin, tak se
 * do dvojmatematickho mdu pepni a pak zase ten pvodn obnov
 *
 * vstup:  p_text - pointer na ukldan tzec
 *
 * vstup: dn
 *
 * cl:   do vstupnho souboru zape poadovan etzec
 *
 */
{
	switch (mod_ukladani) {

		case TEXT			: uloz_retezec(SMEZERA, TEXT);
										uloz_retezec(SDVADOLARY, TEXT);
										uloz_retezec(p_text, TEXT);
										uloz_retezec(SDVADOLARY, TEXT);
										uloz_retezec(SMEZERA, TEXT);
										break;

		case MATMAT		:	uloz_retezec(SMEZERA, TEXT);
										uloz_retezec(p_text, TEXT);
										uloz_retezec(SMEZERA, TEXT);
										break;

		case MAT			:	uloz_retezec(SDOLAR, TEXT);
										uloz_retezec(SMEZERA, TEXT);
										uloz_retezec(SDVADOLARY, TEXT);
										uloz_retezec(p_text, TEXT);
										uloz_retezec(SDVADOLARY, TEXT);
                    uloz_retezec(SMEZERA, TEXT);
										uloz_retezec(SDOLAR, TEXT);
										break;

		default				: TNO("Nelze uloit, jsi v nevhodnm mdu.");
										break;

	}
}

GLOBAL void uloz_poznamky(const char *p_text)
/********************************************
 * uloen textu jako poznmky, je-li zrovna aktuln jin, tak se
 * do poznmkovho mdu pepni a pak zase ten pvodn obnov
 *
 * vstup:  p_text - pointer na ukldan tzec
 *
 * vstup: dn
 *
 * cl:   do vstupnho souboru zape poadovan etzec
 *
 */
{
	MODUKLADANI stary_mod = mod_ukladani;	/* zapamatuj si souasn md */

	uloz_retezec(SPROCENTOMEZERA, POZNAMKY);
	mod_ukladani = POZNAMKY;
	uloz_retezec(p_text, TEXT);
	mod_ukladani = TEXT;
	novy_radek();
	mod_ukladani = stary_mod; /* obnov pvodn md, na 98 to bude TEXT */
}

GLOBAL void novy_radek(void)
/***************************
 * souasn dek zapi do souboru a pesu se na zatek novho
 *
 * vstup:  nic
 *
 * vstup: dn
 *
 */
{
	uloz_retezec(NULL, NOVYRADEK);
}

GLOBAL void uloz_znak(int c)
/***************************
 * ulo znak do vstupnho souboru v TEXTovm mdu
 *
 * vstup:  znak
 *
 * vstup: nic
 *
 */
{
	char s[2];

	s[0] = c;
	s[1] = '\0';
	uloz_retezec(s, TEXT);

}

GLOBAL void *uvolni_pamet(void *p_void)
/**************************************
 * uvolnn alokovan pamti
 *
 * vstup:  pointer na uvolovanou pam؜
 *
 * vstup: NULL
 *
 */
{

	if (testm == TRUE) {
		TNO("-- ??B\t");
	}

	free(p_void);
	return(NULL);
}

GLOBAL void *nova_pamet(long int velikost)
/*****************************************
 * alokuje poadovan poet bajt na HEAPu a vrac pointer na void
 *
 * vstup:  velikost - poet bajt k alokaci, vdy si zjisti velikost pomoc
 *										opertoru sizeof
 *
 * vstup: nen-li pam؜, tak ukon program s chybou
 *				 pointer na void = alokovan pam؜
 *
 */
{
	void *p_void;

	if (testm == TRUE) {
		sprintf(sp, "++%5ldB\t", velikost);
		PRINT
	}

	celkem += velikost;

	if ((p_void = (void *) malloc((size_t) velikost)) == NULL) {
		chyba(NENIPAMET);
		return(NULL);
	}
	else {
		return(p_void);
	}
}

GLOBAL void naucit_prikazy(P_RPR *p_p_rpr, 							/* int *p_pocet_rpr, */
													 P_FONTSUBST *p_p_subrf,
													 P_PREAMBULE *p_p_preambule,
													 P_VELFONTU *p_p_velfontu,
													 P_FONT *p_p_font)
/************************************************************
 * nate z konfiguranho souboru parametry, tabulky a RTF pkazy
 * a ulo do struktur, pro kter si alokuje pam؜ dynamicky
 *
 * vstup:  hodn adres pointer na struktury
 *
 * vstup: nepmo do struktur naleje naten hodnoty
 *
 */
{
	int c;															/* pomocn promnn */
	BOOLEAN konec = FALSE;							/* globln vlajka ukonen uen */
	P_RPR p_koren = NULL; 							/* pracovn ukazatele na koen RTF pkaz */
	P_RPR p_koren2 = NULL;

#if PC
	strcpy(tempcesta, cesta);
	strcat(tempcesta, PARSOUBOR);

	if ((fm = fopen(tempcesta, "r")) == NULL) {
		chyba(NELZEOTEVRIT);
	}
	else {
		if (testi == TRUE) {
			TNO("Soubor s parametry se podailo otevt pro ten.");
		}
	}
#endif

	c = 0;

	while (konec == FALSE) {
		DALSI

		if (c == VYKRICNIK) {

			while (c != UVOZOVKY) {
				DALSI
				if (c == EOF) {
					return;
				}
			}

			strcpy(sp, "");
			nalej(sp);

			if (strcmp(sp, SPP) == 0) {
				BOOLEAN konec = FALSE;

				/* puts("Parametry programu."); */
				c = 0;
				while (konec == FALSE) {
					while (c != UVOZOVKY) {
						DALSI
						if ((c == EOF) || (c == VYKRICNIK)) {
							konec = TRUE;
							/* c = UVOZOVKY; */
							break;
						}
					}

					if (konec == TRUE) {
						break;
					}

					strcpy(sp, "");
					nalej(sp);

					if (strcmp(sp, SVDH) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						if (strcmp(sp, "A") == 0) {
							testd = TRUE;
						}
						else {
							testd = FALSE;
						}
						c = 0;
						continue;
					}

					if (strcmp(sp, SVTCAZ) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						if (strcmp(sp, "A") == 0) {
							testi = TRUE;
						}
						else {
							testi = FALSE;
						}
						c = 0;
						continue;
					}

					if (strcmp(sp, SPMV) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						if (strcmp(sp, "A") == 0) {
							testz = TRUE;
						}
						else {
							testz = FALSE;
						}
						c = 0;
						continue;
					}

					if (strcmp(sp, SDR) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						DELKARADKU = atoi(sp);
						if (DELKARADKU < 3) {
							DELKARADKU = 10;
						}
						c = 0;
						continue;
					}

					if (strcmp(sp, SMDR) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						MAXDELKARADKU = atoi(sp);
						if (MAXDELKARADKU < 5) {
							MAXDELKARADKU = 15;
						}
						c = 0;
						continue;
					}

					if (strcmp(sp, SZV) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						velikostpt = atoi(sp);
						c = 0;
						continue;
					}

					if (strcmp(sp, SPF) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						strcpy(FONTPREPINAC, sp);
						c = 0;
						continue;
					}

					if (strcmp(sp, SUMV) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						ZACATEKVZORCE = atoi(sp);
						c = 0;
						continue;
					}

					if (strcmp(sp, SPPMV) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						POCATEKVZORCE = atoi(sp);
						c = 0;
						continue;
					}

					if (strcmp(sp, SMDMV) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						MAXDELKAVZORCE = atoi(sp);
						c = 0;
						continue;
					}

					if (strcmp(sp, SMDPVMV) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						MAXDELKAPARAM = atoi(sp);
						c = 0;
						continue;
					}

					if (strcmp(sp, SUF) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						if (strcmp(sp, "A") == 0) {
							ukladat_font = TRUE;
						}
						else {
							ukladat_font = FALSE;
						}
						c = 0;
						continue;
					}

					if (strcmp(sp, SUV) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						if (strcmp(sp, "A") == 0) {
							ukladat_velikosti = TRUE;
						}
						else {
							ukladat_velikosti = FALSE;
						}
						c = 0;
						continue;
					}

					if (strcmp(sp, SVP) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						if (strcmp(sp, "A") == 0) {
							vykonavat_prikazy = TRUE;
						}
						else {
							vykonavat_prikazy = FALSE;
						}
						c = 0;
						continue;
					}

					if (strcmp(sp, SURPZV) == 0) {
						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if (c == EOF) {
								konec = TRUE;
								break;
							}
						}
						strcpy(sp, "");
						nalej(sp);
						if (strcmp(sp, "A") == 0) {
							ukladat_rezy = TRUE;
						}
						else {
							ukladat_rezy = FALSE;
						}
						c = 0;
						continue;
					}


				c = 0;
				}
				continue;
			}

			if (strcmp(sp, SPD) == 0) {
				int j = 0;
				BOOLEAN konec = FALSE;

				/* puts("Preabmule."); */
				c = 0;
				while (konec == FALSE) {
					while (c != UVOZOVKY) {
						DALSI
						if ((c == EOF) || (c == VYKRICNIK)) {
							konec = TRUE;
							break;
						}
					}

					strcpy(sp, "");
					nalej(sp);

					if (j == 0) {
						pre1[j].p_text = (char *) nova_pamet(sizeof(char) * strlen(sp) + 1);
						strcpy(pre1[j].p_text, sp);
						pre1[j].p_dalsi = NULL;
					}
					else {
						pre1[j].p_text = (char *) nova_pamet(sizeof(char) * strlen(sp) + 1);
						strcpy(pre1[j].p_text, sp);
						pre1[j].p_dalsi = NULL;
						pre1[j-1].p_dalsi = &pre1[j];
					}
					++j;

					while (1) {
						DALSI
						if (c == VYKRICNIK) {
							konec = TRUE;
							break;
						}
						if (c == UVOZOVKY) {
							break;
						}
					}
				}
				*p_p_preambule = pre1;
				continue;
			}

			if (ini == FALSE) {
				return;
			}

			if (strcmp(sp, SSVF) == 0) {
				int j = 0;
				BOOLEAN konec = FALSE;

				/* puts("Substituce velikosti font."); */
				c = 0;
				while (konec == FALSE) {

					while (c != UVOZOVKY) {
						DALSI
						if (c == EOF) {
							return;
						}
					}

					strcpy(sp, "");
					nalej(sp);

					if (j == 0) {
						vf[j].dolni_mez = atof(sp);
						vf[j].p_dalsi = NULL;
					}
					else {
						vf[j].dolni_mez = atof(sp);
						vf[j].p_dalsi = NULL;
						vf[j-1].p_dalsi = &vf[j];
					}

					c = 0;
					while (c != UVOZOVKY) {
						DALSI
						if (c == EOF) {
							return;
						}
					}

					strcpy(sp, "");
					nalej(sp);
					vf[j].p_texposl = (char *) nova_pamet(sizeof(char) * strlen(sp) + 1);
					strcpy(vf[j].p_texposl, sp);
					++j;

					while (1) {
						DALSI
						if (c == VYKRICNIK) {
							konec = TRUE;
							break;
						}
						if (c == UVOZOVKY) {
							break;
						}
					}
				}
				*p_p_velfontu = vf;
				continue;
			}

			if (strcmp(sp, SSRF) == 0) {
				int j = 0;
				BOOLEAN konec = FALSE;

				/* puts("Substituce rodin fontu.");*/
				c = 0;
				while (konec == FALSE) {
					while (c != UVOZOVKY) {
						DALSI
						if (c == EOF) {
							return;
						}
					}
					strcpy(sp, "");
					nalej(sp);
					rodina[j].rodina_fontu = j;
					rodina[j].p_textposl = (char *) nova_pamet(sizeof(char) * strlen(sp));
					strcpy(rodina[j].p_textposl, sp);
					++j;
					while (1) {
						DALSI
						if (c == VYKRICNIK) {
							konec = TRUE;
							break;
						}
						if (c == UVOZOVKY) {
							break;
						}
					}
				}
				*p_p_subrf = rodina;
				continue;
			}

			if (strcmp(sp, SRP) == 0) {
				int i = 0;
				BOOLEAN konec = FALSE;

				/* puts("RTF pkazy."); */
				c = 0;
				while (konec == FALSE) {

					while (c != UVOZOVKY) {
						DALSI
						if ((c == EOF) || (c == VYKRICNIK)) {
							konec = TRUE;
							break;
						}
					}

					if (konec == TRUE) {
						break;
					}

					{
						P_RPR p_prac;

						p_prac = (P_RPR) nova_pamet(sizeof(RPR));
						p_prac->poradi = i++;

						strcpy(sp, "");
						nalej(sp);
						p_prac->p_jmeno = (char *) nova_pamet(strlen(sp) + 1);
						strcpy(p_prac->p_jmeno, sp);

						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if ((c == EOF) || (c == VYKRICNIK)) {
								konec = TRUE;
								break;
							}
						}

						strcpy(sp, "");
						nalej(sp);
						if (strlen(sp) == 0) {
							p_prac->p_pred = NULL;
						}
						else {
							p_prac->p_pred = (char *) nova_pamet(strlen(sp) + 1);
							strcpy(p_prac->p_pred, sp);
						}

						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if ((c == EOF) || (c == VYKRICNIK)) {
								konec = TRUE;
								break;
							}
						}

						strcpy(sp, "");
						nalej(sp);
						if (strlen(sp) == 0) {
							p_prac->p_stred = NULL;
						}
						else {
							p_prac->p_stred = (char *) nova_pamet(strlen(sp) + 1);
							strcpy(p_prac->p_stred, sp);
						}

						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if ((c == EOF) || (c == VYKRICNIK)) {
								konec = TRUE;
								break;
							}
						}

						strcpy(sp, "");
						nalej(sp);
						if (strlen(sp) == 0) {
							p_prac->p_po = NULL;
						}
						else {
							p_prac->p_po = (char *) nova_pamet(strlen(sp) + 1);
							strcpy(p_prac->p_po, sp);
						}

						c = 0;
						while (c != UVOZOVKY) {
							DALSI
							if ((c == EOF) || (c == VYKRICNIK)) {
								konec = TRUE;
								break;
							}
						}

						p_prac->typpar = atoi(sp);
						p_prac->p_dalsi = NULL;

						if (p_koren == NULL) {
							p_koren = p_prac;
							p_koren2 = p_prac;
							p_koren->p_dalsi = NULL;
						}
						else {
							p_koren->p_dalsi = p_prac;
							p_koren = p_prac;
						}
					}

					while (1) {
						DALSI
						if (c == VYKRICNIK) {
							konec = TRUE;
							break;
						}
						if (c == UVOZOVKY) {
							break;
						}
					}
					c = 0;
				}
				*p_p_rpr = p_koren2;
				continue;
			}

			if (strcmp(sp, STF) == 0) {
				P_FONT p_prac = NULL;
				BOOLEAN konec = FALSE;
				int i = 0;
				int j = 0;	/* pamatuj zapisovan kd ascii znaku do tabulky */

				p_prac = (P_FONT) nova_pamet(sizeof(FONT));
				p_prac->p_nazev = NULL;
				p_prac->typ = UZIVATELSKY;
				p_prac->poradi = fontporadi;
				p_prac->kodovani = ANSI;
				p_prac->p_dalsi = NULL;

				if (p_font1 == NULL) {
					p_font1 = p_prac;
					p_font2 = p_prac;
				}
				else {
					p_font2->p_dalsi = p_prac;
					p_font2 = p_prac;
				}

				for (i = 0; i < MAXZNAK; i++) {
					p_prac->tab_znak[i].mod = NEZAVISLY;
					p_prac->tab_znak[i].delka = 1;
					p_prac->tab_znak[i].ascii =  MEZERA;
					p_prac->tab_znak[i].p_texposl = NULL;
				}

				c = 0;
				while (c != UVOZOVKY) {
					DALSI
					/* if ((c == EOF) || (c == VYKRICNIK)) {*/
					if (c == EOF) {
						konec = TRUE;
						break;
					}
				}

				nalej(sp);
				p_prac->p_nazev = (char *) nova_pamet(sizeof(char) * strlen(sp) + 1);
				strcpy(p_prac->p_nazev, sp);
				if (strcmp(sp, "default") == 0) {
					p_prac->typ = VSEOBECNY;
				}

				c = 0;
				while (c != UVOZOVKY) {
					DALSI
					if ((c == EOF) || (c == VYKRICNIK)) {
						konec = TRUE;
						break;
					}
				}

				nalej(sp);
				if (strcmp(sp, "M") == 0) {
					p_prac->kodovani = MAC;
				}
				if (strcmp(sp, "A") == 0) {
					p_prac->kodovani = ANSI;
				}
				if (strcmp(sp, "P") == 0) {
					p_prac->kodovani = PC;
				}
				if (strcmp(sp, "C") == 0) {
					p_prac->kodovani = PC;
				}

				if (konec == TRUE) {
					break;
				}

				while (konec == FALSE) {
					MODUKLADANI mod = NEZAVISLY;

					while (c != UVOZOVKY) {
						DALSI
						if (c == EOF) {
							konec = TRUE;
							break;
						}
					}

					if (konec == TRUE) {
						break;
					}

					strcpy(sp, "");
					nalej(sp);
					j = atoi(sp);
					c = 0;
					while (c != UVOZOVKY) {
						DALSI
						if (c == EOF) {
							konec = TRUE;
							break;
						}
					}

					if (konec == TRUE) {
						break;
					}

					strcpy(sp, "");
					nalej(sp);

					if (strcmp(sp, "M") == 0) {
						mod = MAT;
					}

					c = 0;
					while (c != UVOZOVKY) {
						DALSI
						if (c == EOF) {
							break;
						}
					}
					strcpy(sp, "");
					nalej_spec(sp);
					/* puts(sp); */
					while ((sp[(i = strlen(sp)) - 1] != UVOZOVKY) || (sp[i - 1] == UVOZOVKY)) {
						if (sp[i-1] == UVOZOVKY) {
							sp[i - 1] = '\0';
							break;
						}
						sp[i - 1] = '\0';
					}
					/* puts(sp); */
					if (mod == MAT) {
						MATUPRAVIT(j, sp)
					}
					else {
						UPRAVIT(j, sp)
					}
					mod = NEZAVISLY;
					c = 0;
					while (1) {
						DALSI
						if (c == VYKRICNIK) {
							konec = TRUE;
							break;
						}
						if (c == UVOZOVKY) {
							break;
						}
					}
				}


				*p_p_font = p_font1;
				continue;
			}

			while (c != VYKRICNIK) {
				DALSI
			}

		}

		if (c == STREDNIK) {
			konec = TRUE;
			continue;
		}

		if (c == EOF) {
			konec = TRUE;
			continue;
		}
	}

	fclose(fm);
}

LOCAL void nalej(char *p_cil)
/****************************
 * do etzce nalije libovoln text z souboru fm a do uvozovek
 */
{
	int i = 0;
	int c;

	c = 0;
	strcpy(p_cil, "");

	while (c != UVOZOVKY) {
		DALSI
		if (c == EOF) {
			return;
		}
		*(p_cil + i++) = c;
		*(p_cil + i) = '\0';
	}

	*(p_cil + --i) = '\0';
}

LOCAL void nalej_spec(char *p_cil)
/*********************************
 * do etzce nalije libovoln text z souboru fm a do konce dku
 */
{
	int i = 0;
	int c;

	c = 0;
	strcpy(p_cil, "");

	while (c != '\n') {
		DALSI
		if (c == EOF) {
			return;
		}
		*(p_cil + i++) = c;
		*(p_cil + i) = '\0';
	}

	*(p_cil + --i) = '\0';
}

GLOBAL void naucit_mat_prikazy(P_MPR *p_p_matpr)
/***********************************************
 * nate do pamti pkazy matematickch vzorek
 *
 * vstup:  pointery na pointery na struktury
 *
 * vstup: nic
 *				 kdy nebude pam؜, program se ukon
 */
{
	/*	FILE *fm;*/
	P_MPR p_koren = NULL;
	P_MPR p_koren2 = NULL;

	strcpy(tempcesta, cesta);
	strcat(tempcesta, MATSOUBOR);

/*	if ((fm = fopen(MATCESTA, "r")) == NULL) {*/

	if ((fm = fopen(tempcesta, "r")) == NULL) {
		TNO("Chyba pi otevrn souboru s matematickmi pkazy.");
		p_p_matpr = NULL;
		return;
	}

	{
		char str1[DELKAMATPAR];
		char str2[DELKAMATPAR];
		char str3[DELKAMATPAR];
		char str4[DELKAMATPAR];
		char str5[DELKAMATPAR];
		char str6[DELKAMATPAR];
		int i = 0;
		int c = 0;
		int j1 = 0;
		int j2 = 0;
		int j3 = 0;
		int j4 = 0;
		int j5 = 0;
		int j6 = 0;

		c = getc(fm);

		while (c != EOF) {

			j1 = 0;
			j2 = 0;
			j3 = 0;
			j4 = 0;
			j5 = 0;
			j6 = 0;
			str1[j1] = '\0';
			str2[j2] = '\0';
			str3[j3] = '\0';
			str4[j4] = '\0';
			str5[j5] = '\0';
			str6[j6] = '\0';

			if (c == STREDNIK) {
				DALSI
				while (c != '\n') {
					DALSI
				}
				DALSI;
				continue;
			}

			while (isspace(c) != FALSE) {
				DALSI
			}

			if (c == UVOZOVKY) {
				DALSI
				while (c != UVOZOVKY) {
					str1[j1] = c;
					j1++;
					str1[j1] = '\0';
					DALSI
				}
			}

			DALSI
			while (c != UVOZOVKY) {
				DALSI
			}

			if (c == UVOZOVKY) {
				DALSI
				while (c != UVOZOVKY) {
					str2[j2] = c;
					j2++;
					str2[j2] = '\0';
					DALSI
				}
			}

			DALSI
			while (c != UVOZOVKY) {
				DALSI
			}

			if (c == UVOZOVKY) {
				DALSI
				while (c != UVOZOVKY) {
					str3[j3] = c;
					j3++;
					str3[j3] = '\0';
					DALSI
				}
			}

			DALSI
			while (c != UVOZOVKY) {
				DALSI
			}

			if (c == UVOZOVKY) {
				DALSI
				while (c != UVOZOVKY) {
					str4[j4] = c;
					j4++;
					str4[j4] = '\0';
					DALSI
				}
			}

			DALSI
			while (c != UVOZOVKY) {
				DALSI
			}

			if (c == UVOZOVKY) {
				DALSI
				while (c != UVOZOVKY) {
					str5[j5] = c;
					j5++;
					str5[j5] = '\0';
					DALSI
				}
			}

			DALSI
			while (c != UVOZOVKY) {
				DALSI
			}

			if (c == UVOZOVKY) {
				DALSI
				while (c != UVOZOVKY) {
					str6[j6] = c;
					j6++;
					str6[j6] = '\0';
					DALSI
				}
			}

			DALSI
			while ((c != '\n') && (c != EOF) ) {
				DALSI
			}

			{
				P_MPR p_prac = NULL;
				int j = 0;

				p_prac = (P_MPR) nova_pamet(sizeof(MPR));
				p_prac->poradi = i++;

				p_prac->p_pred = NULL;
				p_prac->p_stred = NULL;
				p_prac->p_po = NULL;
				p_prac->cislo = 0;
				p_prac->kod = 0;
				p_prac->p_dalsi = NULL;
				p_prac->parametru = 0;

				for (j = 0; j < strlen(str1); j++) {

					p_prac->cislo *= 16;

					if (isalpha(str1[j]) != NULL) {
						p_prac->cislo += str1[j] - 'a' + 10;
					}
					else {
						p_prac->cislo += str1[j] - '0';
					}

				}

				for (j = 0; j < strlen(str2); j++) {

					p_prac->kod *= 16;

					if (isalpha(str2[j]) != NULL) {
						p_prac->kod += str2[j] - 'a' + 10;
					}
					else {
						p_prac->kod += str2[j] - '0';
					}

				}
				p_prac->parametru = atoi(str3);

				if (strlen(str4) == 0) {
					p_prac->p_pred = NULL;
				}
				else {
					p_prac->p_pred = (char *) nova_pamet(strlen(str4) + 1);
					strcpy(p_prac->p_pred, str4);
				}

				if (strlen(str5) == 0) {
					p_prac->p_stred = NULL;
				}
				else {
					p_prac->p_stred = (char *) nova_pamet(strlen(str5) + 1);
					strcpy(p_prac->p_stred, str5);
				}

				if (strlen(str6) == 0) {
					p_prac->p_po = NULL;
				}
				else {
					p_prac->p_po = (char *) nova_pamet(strlen(str6) + 1);
					strcpy(p_prac->p_po, str6);
				}

				p_prac->p_dalsi = NULL;

				if (p_koren == NULL) {
					p_koren = p_prac;
					p_koren2 = p_prac;
					p_koren->p_dalsi = NULL;
				}
				else {
					p_koren->p_dalsi = p_prac;
					p_koren = p_prac;
				}
			}
		}
	}

	fclose(fm);
	*p_p_matpr = p_koren2;
	return;
}


/* GLOBAL void dalsi_mat_znak(void)
/*******************************
 * ped dal kd z matematickho vzoreku
 *
 * vstup:  nic
 *				 pro ten znaku se pouije fce dalsi_znak()
 *
 * vstup: v globlnm etzci matc jsou naten hexa psmena
 *
 */
{
	ukoncit_mat = TRUE;
} */

/************************* definice LOCALnch funkc ************************/

LOCAL void uloz_retezec(const char *p_s, MODUKLADANI mod)
/********************************************************
 * uloen konstantho etzce v poadovanm mdu, provd automatick
 * oezvn na poadovan poet znak na dek
 *
 * vstup:  p_s - pointer na ukldan etzec
 *         mod - poadovan md ukldn
 *
 * vstup: dn
 *
 * nepm vstup: vyst_bafr[DELKABAFRU + 1] - pracovn buffer pro ukldn dky
 *                DELKARADKU    - slo sloupce, pokud me ukldat slova bez
 *																problm
 *                MAXDELKARADKU - slo sloupce, za kter ji nelze uloit ani
 *																, je-li dek bez mezery, tak i tehdy prove
 *																dlen
 *
 */
{
	LOCAL int pozice = 0;					/* aktuln pozice v bufferu */
	LOCAL int pozice_mezery = 0;	/* aktuln pozice mezery v bufferu */
	int m = strlen(p_s);					/* dlka ukldanho etzce */
	int i;												/* poitadlo cyklu */
	char c;												/* pomocn znak */

	if (mod == NOVYRADEK) {				/* ulo rozdlan dek na disk */
		zalomeni(&pozice, &pozice_mezery);
	}
	else {
		for (i = 0; i < m; i++) {		/* vlastn operace na zalomen dky
																		nelze jednodue zkoprovat etzec a pak
																		v nm hledat mezeru, protoe etzec me
																		bt del ne je dlka bafru, a tato funkce
																		MUS BT SCHOPNA uloit etzec libovoln
																		dlky */
			c = *(p_s + i);
			/***************************************/
			if (c == '\r') {
				vyst_bafr[pozice++] = '\n';
				vyst_bafr[pozice] = '\0';
				if (fputs(vyst_bafr, fw) == EOF) {	/* uloen na disk, je-li chyba, tak
																								ukon program (je to v chyba()) */
					chyba(CHYBAZAPISU);
				}
				pozice = 0;
				pozice_mezery = 0;
				vyst_bafr[pozice] = '\0';			/* nuluj etzec */
				return;
			}
			/***************************************/

			if (testh == TRUE) {
				sprintf(sp, "Znak slo %2d = %c", i, c);
				PRINT
			}

			vyst_bafr[pozice++] = c;
			vyst_bafr[pozice] = '\0';

			if (testh == TRUE) {
				sprintf(sp, "Dlka etzce %d, pozice %d", strlen(vyst_bafr), pozice);
				PRINT
			}

			if ((c == MEZERA) && (mod != POZNAMKY)) {
				pozice_mezery = pozice;
				if (pozice > DELKARADKU) {
					zalomeni(&pozice, &pozice_mezery);
				}
			}
			else {	/* nen MEZERA */
				if ((pozice >= MAXDELKARADKU) && (pozice_mezery == FALSE)) {
				/* na dku nen ani jedna mezera a peshl MAXDELKARADKU, proto ulo
						cel dek */
					zalomeni(&pozice, &pozice_mezery);
				}

				if ((pozice >= MAXDELKARADKU) && (pozice_mezery != FALSE)) {
				/* na dku je aspo jedna mezera a jsi na hranici MAXDELKARADKU, proto
						prove zkrcen dky (tzn. uloit ve po posledn registrovanou
						mezeru) */
					zkraceni(&pozice, &pozice_mezery);
				}
			}
		}
	}
}

LOCAL void zalomeni(int *p_pozice, int *p_pozice_mezery)
/*******************************************************
 * ulo rozdlan dek, vynuluje pozice a byl-li v mdu POZNAMKY, tak
 * ulo do vyst_bafr znaky SPROCENTOMEZERA
 *
 * vstup:	 pointery na poitadla pozice v bufferu a posledn mezery
 *
 * vstup: dn
 *
 */
{
	int m = strlen(vyst_bafr);

	if (testh == TRUE) {
		sprintf(sp, "Dlka etzce je %d znak, pozice = %d, mezera = %d", m, *p_pozice,
		*p_pozice_mezery);
		PRINT
		sprintf(sp, vyst_bafr);
		PRINT
	}

	if (m != *p_pozice) {
		TNO("etzec m jinou dlku ne poitadlo pozice!");
	}

	if (testh == TRUE) {
		sprintf(sp, "%s<%d>", vyst_bafr, *p_pozice);
		PRINT
	}

	/* na dku, kde nen mezera najdi odzadu vskyt znaku BACKSLASH, ve po
			tento znak vytiskni do vstupu a prove zalomen dky jako by se
			jednalo o znak MEZERA

	*******************************************************************
	*	 vyuvm toho, e to NKDY zalomit ped BACKSLASH jde bez jmy *
	*	 obecn to ale nejde, take tuto rutinu NEMަU pouvat!!!!!    *
	*******************************************************************

	*/

/*
	if (*p_pozice_mezery == FALSE) 	{

		char *p_b;

		p_b=strrchr(vyst_bafr, BACKSLASH);

		if (p_b != NULL) {

			if (testh == TRUE) {
				sprintf(sp, vyst_bafr);
				PRINT
				sprintf(sp, "Pozice %d", (int) (p_b - vyst_bafr));
				PRINT
			}

			*p_pozice_mezery = (int) (p_b - vyst_bafr);
			zkraceni(p_pozice, p_pozice_mezery);
			return;
		}
	}
 */

	if (fputs(vyst_bafr, fw) == EOF) {	/* uloen na disk, je-li chyba, tak
																					ukon program (je to v chyba()) */
		chyba(CHYBAZAPISU);
	};

	if (fputc('\n', fw) == EOF) {	/* ulo do vstupu znak novho dku */
		chyba(CHYBAZAPISU);
	}

	if (mod_ukladani == POZNAMKY) {				/* ukld-li poznmky, tak dal */
		strcpy(vyst_bafr, SPROCENTOMEZERA);	/* dek mus bt uvozen % */
		*p_pozice = strlen(vyst_bafr);
		*p_pozice_mezery = 0;
	}
	else {
		*p_pozice = 0;										/* nuluj poitadlo pozice v etzci */
		*p_pozice_mezery = 0;							/* nuluj poitadlo mezer */
		vyst_bafr[*p_pozice] = '\0';			/* nuluj etzec */
	}
}

LOCAL void zkraceni(int *p_pozice, int *p_pozice_mezery)
/*******************************************************
 * zkrt rozdlan dek, ulo text po posledn registrovanou mezeru a
 * zbyl etzec posune na zatek dky, byl-li v mdu POZNAMKY, tak
 * ulo do vyst_bafr znaky SPROCENTOMEZERA
 *
 * vstup:	 pointery na poitadla pozice v bufferu a posledn mezery
 *
 * vstup: dn
 *
 */
{
	int m = strlen(vyst_bafr);	/* kontroln poitadlo */
	int i;											/* promnn cyklu */
	char *p_s = vyst_bafr;			/* pomocn pr. pro koprovn etzce */

	if (m != *p_pozice) {
		TNO("etzec m jinou dlku ne poitadlo pozice!");
	}

	if (testh == TRUE) {
		sprintf(sp, vyst_bafr);
		PRINT
	}

	i = vyst_bafr[*p_pozice_mezery - 1];		/* zapamatuj si pemazvan znak */
	vyst_bafr[*p_pozice_mezery - 1] = '\0';	/* zkra etzec */

	if (testh == TRUE) {
		sprintf(sp, vyst_bafr);
		PRINT
	}

	if (fputs(vyst_bafr, fw) == EOF) {	/* uloen na disk, je-li chyba, tak
																					ukon program (je to v chyba()) */
		chyba(CHYBAZAPISU);
	};

	if (fputc('\n', fw) == EOF) {	/* ulo do vstupu znak novho dku */
		chyba(CHYBAZAPISU);
	}

	vyst_bafr[*p_pozice_mezery - 1] = i;	/* obnov pvodn znak */

	/* pepe tu st etzce, kter se ji uloila */
	for (i = 0; i < *p_pozice - *p_pozice_mezery; i++) {
		*(p_s + i) = *(p_s + (*p_pozice_mezery + i)) ;
	}

	vyst_bafr[i] = '\0';
	*p_pozice = strlen(vyst_bafr);

	/* ukld-li poznmky, tak prvn dva znaky musej bt % */
	if (mod_ukladani == POZNAMKY) {
		for (i = 0; i < *p_pozice + 2; i++) {
			*(p_s + *p_pozice - i + 2) = *(p_s + *p_pozice - i);
		}
	*p_s = PROCENTO;
	*(p_s + 1) = MEZERA;

	*(p_s + *p_pozice + 2) = '\0';
	}

	if (testh == TRUE) {
		sprintf(sp, vyst_bafr);
		PRINT
	}


	*p_pozice = strlen(vyst_bafr);	/* nastav poitadla dle aktulnho etzce */
	*p_pozice_mezery = 0;

}
/*************************** konec souboru **********************************/
