/*
 * 14. bezna 1996
 *****************
 */

/*
 * cvr_rtf.c					verze 1
 *
 * funkce pro peklad RTF souboru
 * - verze pro Turbo C 2.0
 *
 * (c) Pavel RAK, 1996.01.07 14:25 vznik souboru
 *
 * soubor nelze it bez svolen autora
 *
 */

/**************************** INCLUDE st **********************************/

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>

/* poad nsledujcch include je ZVAZN */
/*******************************************/
#include "stddef.h"		/* zkladn definice k C, BOOLEAN, EXTERN */
#include "cvr_def.h"  /* definice specifick pro program CVREK */
#include "cvr_rtf.h"  /* svj vlastn hlavikov soubor */
#include "cvr_hla.h"  /* hlavikov soubor hlavn sti programu */
#include "cvr_mat.h"  /* hlavikov soubor pekladae vzorek */


/**************************** lokln define ********************************/
#define PAUSE	{getch();}
#define PRIDEJ(x) { p_rzas = pridej_rzas(p_rzas, rtfz, (x));}

/************************* IMPORTovan objetky ******************************/
/* testovan vpisn vlajky */
/*****************************/
EXPORT BOOLEAN testa;
EXPORT BOOLEAN testb;
EXPORT BOOLEAN testd;
EXPORT BOOLEAN teste;
EXPORT BOOLEAN testf;
EXPORT BOOLEAN testh;
EXPORT BOOLEAN testi;
EXPORT BOOLEAN testk;
EXPORT BOOLEAN testm;
EXPORT BOOLEAN testt;
EXPORT BOOLEAN testv;
EXPORT BOOLEAN testz;
EXPORT int POCATEKVZORCE;		/* od kter pozice lze oekvat zatek vzoreku */
EXPORT int ZACATEKVZORCE;		/* kd znaku, kter uvozuje vzoreek (0x0a) */
EXPORT int MAXDELKAVZORCE;	/* maximln dlka matematickho vzoreku */
EXPORT int MAXDELKAPARAM;		/* maximln dlka matematickho parametru */
EXPORT int DELKARADKU;
EXPORT int MAXDELKARADKU;

EXPORT FILE *fc;
EXPORT char sp[];

/*************************** globln promnn ******************************/

GLOBAL BOOLEAN ukoncit = FALSE;	/* zda se m peklad ukonit */
GLOBAL long int znaku = 0;			/* poet skuten natench znak */
GLOBAL int c = 0;								/* pomocn promnn znaku */
GLOBAL int d = 0;								/* pomocn promnn pedchzejcho znaku */
GLOBAL BOOLEAN do_poznamek = FALSE; /* ukldat zprvy o pkazech? */
GLOBAL int velikostpt; /* st. velikost psma */
GLOBAL BOOLEAN ukladat_font = TRUE;				/* vlajka, zda ukldat definice font
																							a akceptovat pepnn font */
GLOBAL BOOLEAN ukladat_velikosti = TRUE;	/* vlajka, zda ukldat velikosti font */
GLOBAL BOOLEAN vykonavat_prikazy = TRUE;	/* vlajka, zda vbec pekldat pkazy */
GLOBAL BOOLEAN ukladat_rezy = FALSE;	/* vlajka, zda ukldat \bold a \italic
																					po zmn velikosti nebo typu psma*/
GLOBAL char FONTPREPINAC[30];	/* text pro generovn textu pro pepnut fontu */

/**************************** lokln promnn ******************************/
LOCAL P_RPR p_srpr = NULL;			/* hlavn pointer na seznam pkaz RTF */
LOCAL P_RPR prikaz = NULL;			/* pomocn pt. na fci pkazu psl. RTF pkazu */
/* LOCAL int pocet_rpr;						/* poet nauench RTF pkaz */ */
LOCAL P_FONTSUBST p_ssubrf = NULL;			/* substitun tabulka rodin font */
LOCAL P_PREAMBULE p_spreambule = NULL;	/* text preambule */
LOCAL P_VELFONTU p_svelikost = NULL;		/* substitun tabulka velikosti font */
LOCAL P_FONT p_sfont= NULL;			/* kdovac tabulky font, 256 poloek*/
LOCAL float font_dolni_mez; 		/* koeficient doln meze pro velikost fontu */
LOCAL float font_horni_mez; 		/* koeficient horn meze pro velikost fontu */
LOCAL P_RTFZAS p_rzas= NULL;		/* pointer za zsobnk rtf akc */
LOCAL BOOLEAN inicializace;			/* flag, zda ji probhla inicializace */
/*LOCAL BOOLEAN font_tabule = FALSE; 	/* zda je natena fontov tabulka */*/
/*LOCAL BOOLEAN styl_tabule = FALSE;	/* zda je natena tabulka styl */*/
/*LOCAL BOOLEAN je_object = FALSE;		/* zda se zpracovv \object */*/
LOCAL BOOLEAN byl_pard = FALSE;			/* byl ji pard - ukazatel, e ji skonila
																				hlavika dok. a zan text */
LOCAL BOOLEAN byl_fonttbl = FALSE;	/* vlajka, e ji byly ve vstupnm souboru
																				definovny fonty */
LOCAL BOOLEAN hvezda = FALSE;				/* zpracovvm pkazy uvozen * */
LOCAL BOOLEAN byla_zavorka = FALSE; /* byla ped pkazem zvorka */
LOCAL BOOLEAN cist = TRUE;	/* mm st znak ze vstupu?, kvli funkcm,
																kter provdj sekvenn ten ze vstupu
																nap. pesko_skupinu() */
LOCAL BOOLEAN parpar = FALSE;	/* vlajka, e pedchzejc pkaz byl par */
LOCAL BOOLEAN normalsize = FALSE;	/* vlajka, e aktuln velikost psma je \normalsize */
LOCAL REZY aktualni_rez = RM;	/* pepna urujc aktuln ez psma */

LOCAL KODFONTU kodovani = ANSI;			/* kdovn dokumentu */
LOCAL TEXSKUPINA tex_skupina = ZADNA;	/* aktuln (La)TeXov skupina */
LOCAL BOOLEAN podcarou = FALSE;			/* vlajka, je-li zrovna u poz. pod arou */
LOCAL char *p_t_tex_skupina = NULL;	/* pointer na text uzavrajc (La)TeX
																				skupinu (nap. \end{center}) */

LOCAL BOOLEAN objekt = FALSE;	/* vlajka, e je ve skupin \object */
LOCAL OBJEKTY typ_objektu = NEDEFINOVAN;	/* typ zpracovvanho objektu */
LOCAL BOOLEAN preskoceni = TRUE;	/* peskakuj zbytn text za \* */

/* fonty definovan v souboru */
/******************************/
/*LOCAL FONTTAB prac_fontik;			/* pracovn zznam fontu (vyuije se pi
																		definici fontov tabulky) */*/
/* LOCAL RODINA rodina_fontu = 0;			/* pracovn slo rodiny fontu */*/
/****************** zbyten *******************************************/
/*LOCAL long int font_cislo = 0;			/* pracovn slo fontu */*/
LOCAL P_FONTTAB p_tabfontu = NULL;	/* pointer na koen tabulky font */
LOCAL P_FONTTAB p_akt_font = NULL;	/* pointer na aktuln font */
/*LOCAL long int default_font = 0;		/* slo defaultnho fontu (definuje \deff) */*/
/*LOCAL long int pocet_fontu = 0;			/* poet nadefinovanch font v RTF souboru */*/

/* rozmry dokumentu */
/*********************/
LOCAL int vyska = 0;						/* vka dokumentu v TWIPS */
LOCAL int sirka = 0;						/* ka dokumentu v TWIPS */
LOCAL int levy_okraj = 0;				/* vzdlenost levho okraje v TWIPS */
LOCAL int pravy_okraj = 0;			/* vzdlenost pravho okraje v TWIPS */
LOCAL int horni_okraj = 0;			/* vzdlenost hornho okraje v TWIPS */
LOCAL int dolni_okraj = 0;			/* vzdlenost dolnho okraje v TWIPS */
LOCAL int pevensidemargin = 5;	/* rozmr v milimetrech */
LOCAL int poddsidemargin = 5;		/* rozmr v milimetrech */
LOCAL int rtfz = 0;							/* aktuln slo zvorky dokumentu */
LOCAL long int cislo_fontu = 0;			/* aktuln slo fontu - pevzat z fonttbl */
LOCAL long int default_cislo_fontu = 0; /* defaultn slo fontu */
/*LOCAL int predch_prikaz;				/* slo pechzejcho pkazu */*/
LOCAL int icispar = 0;					/* int parametr, pro vmnu mezi funkcemi */
LOCAL long int lcispar = 0;					/* long parametr, pro vmnu mezi funkcemi */

LOCAL char radek_a[MAXIMALNIDELKARADKU];	/* pracovn dek */
LOCAL char radek_b[MAXIMALNIDELKARADKU];	/* pracovn dek */
LOCAL int delka_a = 0;	/* pozice znaku v radek_a */
LOCAL int delka_b = 0;	/* pozice znaku v radek_b */

/****************** pln funkn prototypy globlnch funkc ***************/
GLOBAL BOOLEAN preloz_rtf(void);
GLOBAL void preskoc_skupinu(void);

/****************** pln funkn prototypy loklnch funkc ****************/
LOCAL P_RPR existuje(const char *p_jmpr, P_RPR koren);
LOCAL void vypis_rpr(P_RPR prikaz);
LOCAL void seznam_prikazu(P_RPR koren);
LOCAL void seznam_subrf(P_FONTSUBST koren);
LOCAL void seznam_preambule(P_PREAMBULE p_koren);
LOCAL void seznam_velikosti(P_VELFONTU p_koren);
/* LOCAL void seznam_fontu(P_FONT p_koren);*/
LOCAL void vypis_default(void);
LOCAL void nastav_default(void);
LOCAL void zpracovani(void);
LOCAL void nacti_cpar(void);
LOCAL void uloz_pismeno(int znak);
LOCAL void vypis_fonttab(P_FONT p_vrchol);
LOCAL void vypis_fonttbl(P_FONTTAB p_vrchol);
LOCAL void uprav_cislovani(char retezec[], int cislo);

/*LOCAL void vypis_rzas(P_RTFZAS p_vrchol);*/
LOCAL P_RTFZAS pridej_rzas(P_RTFZAS p_vrchol, int zavorka, AKCE ukol);
LOCAL P_RTFZAS zrus_rvrchol(P_RTFZAS p_vrchol);
LOCAL void vykonej_rzas(P_RTFZAS p_vrchol);

/* nathni tla funkc pkaz RTF */
/***********************************/
#include "cvr_fce.c"	/* funkce k RTF pkazm */

/************************ definice GLOBALnch funkc ************************/

GLOBAL BOOLEAN preloz_rtf(void)
/******************************
 * konverze RTF souboru
 *
 * vstup:  dn
 *
 * vstup: BOOLEAN hodnota: TRUE  - peklad OK
 *													FALSE - nebyly ukoneny skupiny RTFka nebo TeXu
 *													ERROR - neoekvan konec souboru
 *
 */
{

	if (inicializace == FALSE) {
		naucit_prikazy(&p_srpr,
																/* &pocet_rpr,*/
			&p_ssubrf,
			&p_spreambule,
			&p_svelikost,
			&p_sfont);	/* nau se pkazy RTF */
		inicializace = TRUE;	/* nastav vlajku, e jsi ji do pamti zavedl
															struktury z RESOURCE nebo nkud jinud */

		if (p_srpr == NULL) {				/* otestuj, zda jsi sprvn inicializoval */
			chyba(CHYBAINICIALIZACE);	/* vechny zkladn struktury */
		}
  	if (p_ssubrf == NULL) {
			chyba(CHYBAINICIALIZACE);
		}
  	if (p_spreambule == NULL) {
			chyba(CHYBAINICIALIZACE);
		}
		if (p_svelikost == NULL) {
			chyba(CHYBAINICIALIZACE);
		}
		if (p_sfont == NULL) {
			chyba(CHYBAINICIALIZACE);
		}

		if (testv == TRUE) {
			seznam_prikazu(p_srpr);
		}

	}
	else {
		TNO("Inicializace ji probhla.");
	}

	nastav_default();	 	/* nastav defaultn rozmry pro dokument */
	/*	nastav_parametry(); /* nastav parametry pekladu */*/

	if (testd == TRUE) {
		vypis_default();
	}

	/* uloen hlaviky (autor, copyright, apod.)*/

/*	preloz_vzorec();
	uloz_text("\\bye\r");*/

	while (ukoncit != TRUE) {	/* zkladn programov smyka */
		zpracovani();
	}

	/* uzavt skupiny */

	if (testi == TRUE) {
		TNO("Konec pekladu.");
	}

	if (testi == TRUE) {
		sprintf(sp, "Nateno %lu znak.", znaku);
		PRINT
	}

	if (rtfz != 0) {
		chyba(CHYBNYVSTUPNISOUBOR);
	}

	return(TRUE);
}

GLOBAL void preskoc_skupinu(void)
/********************************
 * pesko skupinu {} nebo JEN PESKO TEXT DO KONCE SKUPINY (superrrrrrr)
 *
 * vstup: dn
 *
 * vstup: dn
 *
 * cl:    pesko vechny {} vetn veho co je mezi tm, nic nevykonv
 *
 * varovn: funkci lze bezpen volat jen kdy je natena aspo jedna {
 *						kvli vymoenosti, e jen pesko text do konce skupiny
 *						je funkce pomrn komplikovan :-(((((((((
 *
 */
{
	int uroven = 1;					/* poitadlo zvorek */
/*	BOOLEAN prava = FALSE;	/* vlajka, e je natena aspo jedna lev zvorka */*/

	if (c == PSLOZENA) {
		return;
	}

	if (c == LSLOZENA) {
		++uroven;
	}
	while ((c = dalsi_znak()) != EOF) {
		if (c == LSLOZENA) {
/*			prava = TRUE;*/
			++uroven;
			continue;
		}
		if (c == PSLOZENA) {
			--uroven;
			if (uroven < 1) {
				cist = FALSE;
				break;
			}
		}
	}
	cist = FALSE;
}

/************************* definice LOCALnch funkc ************************/

LOCAL void zpracovani(void)
/**************************
 * zpracovn znak, dekdovn pkaz, voln pkaz apod.
 *
 * vstup:  dn
 *
 * vstup: dn
 *
 * cl:    zde se postupn nataj jednotliv znaky vstupnho souboru,
 *					provd se jejich pepis na znaky vstupnho souboru, ppadn
 *					se volaj funkce
 */
{

	if (cist != FALSE) {	/* mohu-li st znak, tak ho petu */
		if ((c = dalsi_znak()) == NULL) {	/* jsi-li ji na konci souboru, zpt */
			return;
		}
	}

	cist = TRUE;	/* povol ji normln natn ze vstupnho soubouru */

	if (c == LSLOZENA) {
		++rtfz;
/*		PRIDEJ(UKONCIZAVORKU);	/* zvorky na vstupu kopruj do vstupu */
		if (byl_pard == TRUE) {
			uloz_text(SLSLOZENA);
		}*/
		return;
	}

	if (c == PSLOZENA) {

		for (;;) {
			if (p_rzas == NULL) {
				break;
			}
			if ((p_rzas != NULL) && (p_rzas->cislo_zavorky < rtfz)) break;
			if ((p_rzas != NULL) && (p_rzas->cislo_zavorky == rtfz)) {
				vykonej_rzas(p_rzas);
				p_rzas = zrus_rvrchol(p_rzas);
				continue;
			}
			if ((p_rzas != NULL) && (p_rzas->cislo_zavorky > rtfz)) {
				TNO("Na zasobniku je nedokoncena akce k zavorce.");
				break;
			}
		}

		--rtfz;
		if (rtfz == 0) {	/* posledn zvorka dokumentu */

			if (ukoncit == TRUE) {
				chyba(CHYBNYVSTUPNISOUBOR);
			}

			ukoncit = TRUE;
		}
		return;
	}

	if (c == BACKSLASH) {								/* zpracovn RTF pkaz */

		delka_a = 0;			/* nuluj dlku prvnho pracovnho etzce */
		delka_b = 0;			/* nuluj dlku druhho pracovnho etzce */
		icispar = 0;			/* nuluj globln parametrovou int promnnou */
		lcispar = 0;			/* nuluj globln parametrovou long promnnou */
		radek_a[0] = '\0';	/* vynuluj etzce */
		radek_b[0] = '\0';


		if (d == LSLOZENA) {	/* znaka, e \ pedchzela } */
			byla_zavorka = TRUE;
		}
		else {
			byla_zavorka = FALSE;
		}

		if ((c = dalsi_znak()) == NULL) { /* kdyby nhodou byl konec, tak nvrat */
			return;
		}

		else {

			if (isalpha(c) != FALSE) {				/* zpracuj pkaz sloen z psmen */

				while (isalpha(c) != FALSE) {
					radek_a[delka_a++] = c;				/* znaky pkazu ukldej do radek_a */

					if (delka_a == (MAXIMALNIDELKARADKU - 1)) {
						chyba(DLOUHYPRIKAZ);	/* kdy peshne dlku bafru, koni s chybou */
					}

					radek_a[delka_a] = '\0';	/* ukoni sprvn etzec */

					if ((c = dalsi_znak()) == NULL) { /* nati dal znak */
						return;
					}

				}

				nacti_cpar();	/* naten selnho paramteru, nem-li pkaz
													seln par., tak lcispar m hodnotu ERROR (-1) */

				/* najdi pkaz ve struktue RPR (RTF pkazy) */
				if ((prikaz = existuje(radek_a, p_srpr)) == NULL) {

					/* pkaz neznm, tak se ozvi a zapi do vstupu */
					if (hvezda == TRUE) {
						if (testf == TRUE) {
							sprintf(sp, "Prikaz %s nemusis znat.", radek_a);
							PRINT
						}
					}

					sprintf(radek_b, "pkaz >%15s< nen implementovn", radek_a);
					if (do_poznamek == TRUE) {
						uloz_poznamky(radek_b);
					}
				}
				else {
					/* vykonn pkazu */
					/********************/
					sprintf(radek_b, "%15s vykonn", radek_a);
					if (do_poznamek == TRUE) {
						uloz_poznamky(radek_b);
					}

					if (strcmp(radek_a, "par") == 0) {
						parpar = TRUE;
					}
					else {
						parpar = FALSE;
					}

					p_tabrtf[prikaz->poradi]();
					cist = FALSE;
					return;
				}

				cist = FALSE;
				return;
			}

			else {					/* nen to pkaz, ale jedonopsmenn speciln pkaz */

				if (c == LSLOZENA) {	/* znak { */
					uloz_text(SBACKSLASH);
					uloz_text(SLSLOZENA);
					return;
				}

				if (c == PSLOZENA) {	/* znak } */
					uloz_text(SBACKSLASH);
					uloz_text(SPSLOZENA);
					return;
				}

				if (c == SVISLA) {	/* znak | (formula character) */
					return;
				}

				if (c == VLNKA) {		/* znak ~ (nedliteln mezera) */
					uloz_text(SVLNKA);
					return;
				}

				if (c == MINUS) {		/* voliteln dlen */
					uloz_text(SBACKSLASH);
					uloz_text(SMINUS);
					return;
				}

				if (c == PODTRZENI) {	/* znak \_ */
					return;
				}

				if (c == APOSTROF) {	/* znak s ascii > 128 */
					dalsi_znak();
					dalsi_znak();
					c = tolower(c);
					d = tolower(d);
					if (isalpha(d) != NULL) {
						icispar = d - 'a' + 10;
					}
					else {
						icispar = d - '0';
					}
					icispar *= 16;
					if (isalpha(c) != NULL) {
						icispar += (c - 'a' + 10);
					}
					else {
						icispar += (c - '0');
					}

					if (icispar < MEZERA) {
						icispar = MEZERA;
					}
					uloz_pismeno(icispar);
					return;
				}

				if (c == HVEZDICKA) {	/* nov pkazy, defaultn peskakuji */
						hvezda = TRUE;
						PRIDEJ(NULUJHVEZDU);
/*					if (byla_zavorka == TRUE) { /******** pozor, nezapnat *******/
						preskoc_skupinu();
					}*/
					zpracovani();

					if (preskoceni == TRUE) {
						preskoc_skupinu();
					}

					return;
				}

				if (c == DVOJTECKA) {
					return;
				}

				if (c == BACKSLASH) {	/* zprac. \\, jsi-li v {\*\\, tak to ignoruj} */
					if (hvezda == TRUE) {
						return;
					}
					else {	/* ulo znak backslashe v matem. mdu */
						uloz_mat_symbol(RBACKSLASH);
						return;
					}
				}

			return;
			}
		}
	}

	if (byl_pard == TRUE) {	/* jsi-li mimo definice a po preambuli,
															tak znaky ukldej */

		/* tabulky znak se budou brt z p_tabfontu, kde se podle aktulnho sla
				fontu v tabulce nalezne pointer na FONTovou tabulku */
		{
			P_FONTTAB p_koren = p_tabfontu;
			P_ZNAK p_vrchol = NULL;

			while (p_koren != NULL) {

				if (p_koren->cislo == cislo_fontu) {
					p_vrchol = p_koren->p_tabulka_znak + c;

					if (p_vrchol->delka == 1) {
						uloz_pismeno(p_vrchol->ascii);
					}
					else {
						switch (p_vrchol->mod) {

							case NEZAVISLY: uloz_nezav_text(p_vrchol->p_texposl);
															break;

							case MAT: uloz_mat(p_vrchol->p_texposl);
												break;

							default:	uloz_nezav_text(p_vrchol->p_texposl);
												break;
						}
					}
					break;
				}
				p_koren = p_koren->p_dalsi;
			}

			if (p_vrchol == NULL) {
				TNO("Poaduje se pepnut na nedefinovan font. Nastavuji standardn.");
				cislo_fontu = default_cislo_fontu;
			}
		}
	}
}

LOCAL void nastav_default(void)
/******************************
 * nastav defaultn hodnoty globlnch promnnch
 *
 * vstup:  dn
 *
 * vstup: dn
 *
 * cl:    u mnoha globlnch promnnch nastav defaultn hodnoty
 *
 */
{
	P_VELFONTU p_vf = p_svelikost;

	font_dolni_mez = p_svelikost->dolni_mez;	/* doln mez koefic. pro fonty */

	while (p_vf != NULL) {										/* horn mez koefic. pro fonty */
		font_horni_mez = p_vf->dolni_mez;				/* vezmi jednodue posledn prvek */
		p_vf = p_vf->p_dalsi;
	}

	sirka = 11880;	/* rozmry strnky vetn okraj (TWIPSy) */
	vyska = 16840;
	pravy_okraj = levy_okraj = 1701;
	horni_okraj = dolni_okraj = 1417;

	pevensidemargin = 5;	/* rozmry v milimetrech */
	poddsidemargin = 5;

}

LOCAL void vypis_default(void)
/*****************************
 * vype defaultn hodnoty u globlnch promnnch
 *
 * vstup:  dn
 *
 * vstup: dn
 *
 * cl:    na obrazovku vype zamen promnn a jej obsah
 *
 */
{
	sprintf(sp, "");
	PRINT
	sprintf(sp, "******************* defaultn hodnoty *******************");
	PRINT
	sprintf(sp, "");
	PRINT
	sprintf(sp, "  doln mez koeficientu pro font: %.2f", font_dolni_mez);
	PRINT
	sprintf(sp, "  horn mez koeficientu pro font: %.2f", font_horni_mez);
	PRINT
	sprintf(sp, "  vpis default: %d", testd);
	PRINT
	sprintf(sp, "  vpis vstupn/vstupnch text: %d", testi);
	PRINT
	sprintf(sp, "  peklad vzorek: %d", testz);
	PRINT
	sprintf(sp, "  dlka dku: %d", DELKARADKU);
	PRINT
	sprintf(sp, "  maximln dlka dku: %d", MAXDELKARADKU);
	PRINT
	sprintf(sp, "  defaultn velikost: %d", velikostpt);
	PRINT
	sprintf(sp, "  pepna font: `%s'", FONTPREPINAC);
	PRINT
	sprintf(sp, "  pozice zatku vzoreku: %d", POCATEKVZORCE);
	PRINT
	sprintf(sp, "  znak zatku vzoreku: %d", ZACATEKVZORCE);
	PRINT
	sprintf(sp, "  maximln dlka jednoho vzoreku: %d", MAXDELKAVZORCE);
	PRINT
	sprintf(sp, "  maximln dlka jednoho parametru vzoreku: %d", MAXDELKAPARAM);
	PRINT
	sprintf(sp, "  ukldn font: %d", ukladat_font);
	PRINT
	sprintf(sp, "  ukldn velikost font: %d", ukladat_velikosti);
	PRINT
	sprintf(sp, "  vykonvat pkazy: %d", vykonavat_prikazy);
	PRINT
	sprintf(sp, "  ukldat ezy po zmn velikosti: %d", ukladat_rezy);
	PRINT
	sprintf(sp, "");
	PRINT
	seznam_subrf(p_ssubrf);
	sprintf(sp, "");
	PRINT
	seznam_preambule(p_spreambule);
	sprintf(sp, "");
	PRINT
	seznam_velikosti(p_svelikost);
	/*	seznam_fontu(p_sfont);*/
	sprintf(sp, "");
	PRINT
	vypis_fonttab(p_sfont);
	sprintf(sp, "*************** konec vpisu def. hodnot ****************");
	PRINT
	sprintf(sp, "");
	PRINT
}

LOCAL P_RPR existuje(const char *p_jmpr, P_RPR p_koren)
/******************************************************
 * nalezne v tabulce pkaz poadovan pkaz
 *
 * vstup:  p_jmpr - jmno hledanho pkazu
 *				 p_koren - pointer na koen stuktury RTF pkaz
 *
 * vstup: pointer na strukturu s pkazem jinak NULL
 *
 * cl:		 vyhledn pkazu, kter znm a mm implementovny
 *
 */
{

	while (p_koren != NULL) {
		if (strcmp(p_jmpr, p_koren->p_jmeno) == FALSE) {
			return(p_koren);
		}
		p_koren = p_koren->p_dalsi;
	}
	return(NULL);
}

LOCAL void vypis_rpr(P_RPR p_prikaz)
/***********************************
 * vype podrobnosti k natenmu pkazu
 *
 * vstup:  p_prikaz - pointer na pkaz
 *
 * vstup: dn
 *
 */
{
	if (p_prikaz == NULL) {
		TNO("Nelze vypsat informace o pkazu, protoe pointer ukazuje na NULL.");
		return;
	}
	sprintf(sp ,"pkaz '%s', typ parametru: '%d', poad: '%d', dal typ: '%p'",
		p_prikaz->p_jmeno, p_prikaz->typpar, p_prikaz->poradi, p_prikaz->p_dalsi);
	PRINT
	sprintf(sp, "  texty: '%s', '%s', '%s'", p_prikaz->p_pred, p_prikaz->p_stred, p_prikaz->p_po);
	PRINT
}

LOCAL void seznam_prikazu(P_RPR p_koren)
/***************************************
 * vype seznam vech definovanch funkc jazyka RTF;
 * vpis je ve fci vypis_rpr()
 *
 * vstup:  p_koren - pointer na koen struktury pkaz RTF
 *
 * vstup: dn
 *
 */
{
	while (p_koren != NULL) {
		vypis_rpr(p_koren);
		p_koren = p_koren->p_dalsi;
	}
}

LOCAL void seznam_subrf(P_FONTSUBST p_koren)
/*******************************************
 * vype substitun tabulku font
 *
 * vstup:  p_koren - pointer na koen strukturu substitun tabulky font
 *
 * vstup: dn
 *
 */
{
	if (p_koren == NULL) {
		TNO("Substitun tabulka rodiny font je przdn.");
	}
	else {
		sprintf(sp, "********** substitun tabulka rodiny font **********");
		PRINT
		sprintf(sp, "");
		PRINT
		sprintf(sp, "  fnil:   \t %s",	(p_koren + 0)->p_textposl);
		PRINT
		sprintf(sp, "  froman: \t %s",	(p_koren + 1)->p_textposl);
		PRINT
		sprintf(sp, "  fswiss: \t %s",	(p_koren + 2)->p_textposl);
		PRINT
		sprintf(sp, "  fmodern:\t %s", (p_koren + 3)->p_textposl);
		PRINT
		sprintf(sp, "  fscript:\t %s", (p_koren + 4)->p_textposl);
		PRINT
		sprintf(sp, "  fdecor: \t %s",	(p_koren + 5)->p_textposl);
		PRINT
		sprintf(sp, "  ftech:  \t %s",	(p_koren + 6)->p_textposl);
		PRINT
	}
}

LOCAL void seznam_preambule(P_PREAMBULE p_koren)
/***********************************************
 * vype preambuli
 *
 * vstup:  p_koren - pointer na koen strukturu tabulky preambule
 *
 * vstup: dn
 *
 */
{
	sprintf(sp, "********** preambule **********");
	PRINT
	sprintf(sp, "");
	PRINT
	while (p_koren != NULL) {
		sprintf(sp, p_koren->p_text);
    PRINT
		p_koren = p_koren->p_dalsi;
	}
}

LOCAL void seznam_velikosti(P_VELFONTU p_koren)
/**********************************************
 * vype tabulku velikosti font
 *
 * vstup:  p_koren - pointer na koen struktury tabulky velikosti font
 *
 * vstup: dn
 *
 */
{
	sprintf(sp, "********** velikosti font **********");
	PRINT
	sprintf(sp, "");
	PRINT
	sprintf(sp, "doln mez\tpkaz");
	while (p_koren != NULL) {
		sprintf(sp, "  %.2f \t\t %s", p_koren->dolni_mez, p_koren->p_texposl);
		PRINT
		p_koren = p_koren->p_dalsi;
	}
}

/*LOCAL void seznam_fontu(P_FONT p_koren)
/**************************************
 * vype seznam font, ppadn i tabulku
 *
 * vstup:  p_koren - pointer na koen struktury tabulky font
 *
 * vstup: dn
 *
 */
{
	sprintf(sp, "********** seznam font **********");
	PRINT
	sprintf(sp, "");
	PRINT

	while (p_koren != NULL) {

		int i;	/* promnn cyklu */

		sprintf(sp, "nzev: '%s', typ: '%d', tabulka znaku: '%p'"
						"kdovn: '%d', poad: '%d', dal: '%p'",
						 p_koren->p_nazev, p_koren->typ, p_koren->tab_znak,
						 p_koren->kodovani, p_koren->poradi, p_koren->p_dalsi);
		PRINT
		if (p_koren->tab_znak != NULL) {
			sprintf(sp, "Tabulka znak:");
			PRINT
			for (i = 0; i < MAXZNAK; i+=63) {
				sprintf(sp, "cislo: %3d mod: %3d delka: %3d ascii: %3d (%c) text: %s",	i, (p_koren->tab_znak + i)->mod, (p_koren->tab_znak + i)->delka, (p_koren->tab_znak + i)->ascii,
				 (p_koren->tab_znak + i)->ascii,	(p_koren->tab_znak + i)->p_texposl);
				PRINT
			}
		}
		p_koren = p_koren->p_dalsi;
	}
} */

LOCAL void nacti_cpar(void)
/**************************
 * nate seln parametr za pkazem
 *
 * vstup:  dn
 *
 * vstup: dn
 *
 * cl: do globln promnn icispar a lcispar se ulo seln parametr;
 *			kdy dn nen, ulo se tam -1
 */
{
	BOOLEAN minus = FALSE;

	lcispar = icispar = ERROR;		/* nastav defaultn, e nen dn parametr */

	if (c == EOF) {			/* je-li na konci, tak se vra */
		return;
	}

	cist = FALSE;				/* kdy jsi nco naetl, tak zaka znovunatn */

	if (c == MINUS) {
		minus = TRUE;
		c = dalsi_znak();
	}
	else {
		if (isdigit(c) == FALSE) {	/* je-li dal znak neslice, tak se vra */
			return;
		}
	}

	/* zpracuj seln paramter */
	lcispar = icispar = 0;

	while (isdigit(c) != FALSE) {
		lcispar = (lcispar * 10) + (c - '0');
		c = dalsi_znak();
	}

	cist = FALSE;

	if (minus == TRUE) {
		lcispar *= -1;
	}

	icispar = (int) lcispar;
}

LOCAL void uloz_pismeno(int znak)
/********************************
 * ulo psmeno podle aktuln fontov tabulky
 *
 * vstup:  ascii hodnota znaku
 *
 * vstup: dn
 *
 * z aktulnho sla fontu zjist kdovou tabulku, a podle sla znaku ulo
 * bu znak, nebo text v pslunm mdu
 *
 */
{
	uloz_znak(znak);
}

LOCAL P_RTFZAS zrus_rvrchol(P_RTFZAS p_vrchol)
/*********************************************
 * zru vrchol zsobnku
 */
{
	P_RTFZAS p_prac = p_vrchol;

	if (p_vrchol == NULL) {
		TNO("Nelze rusit prazdny zasobnik");
		return(NULL);
	}

	p_vrchol = p_vrchol->p_pred;
	p_vrchol->p_dalsi = uvolni_pamet((void *) p_prac);
	return(p_vrchol);
}

LOCAL P_RTFZAS pridej_rzas(P_RTFZAS p_vrchol, int zavorka, AKCE ukol)
/********************************************************************
 * pid na RTF zsobnk slo zvorky a udlost s n souvisejc
 *
 * vstup:
 *
 * vstup:
 */
{
	P_RTFZAS p_prac;

	p_prac = (P_RTFZAS) nova_pamet(sizeof(RTFZAS));

	p_prac->cislo_akce = ukol;
	p_prac->cislo_zavorky = zavorka;
	p_prac->p_dalsi = NULL;
	p_prac->p_pred = p_vrchol;
	p_prac->parametr = cislo_fontu;

	if (p_vrchol != NULL) {
		p_vrchol->p_dalsi = p_prac;
	}

	return(p_prac);
}

/*LOCAL void vypis_rzas(P_RTFZAS p_vrchol)
/***************************************
 * vypi RTF zsobnk
 */
{
	while (p_vrchol != NULL) {
		sprintf(sp, "adresa: %p", p_vrchol);
		PRINT
		sprintf(sp, "Zavorka: %d", p_vrchol->cislo_zavorky);
		PRINT
		sprintf(sp, "Cislo akce: %d ", p_vrchol->cislo_akce);
		PRINT
		sprintf(sp, "Dalsi %p", p_vrchol->p_dalsi);
		PRINT
		sprintf(sp, "Predchazejici %p", p_vrchol->p_pred);
		PRINT
		p_vrchol = p_vrchol->p_pred;
	}
}*/

LOCAL void vypis_fonttab(P_FONT p_vrchol)
/****************************************
 * vpis natench fontovch tabulek ze zdroj
 */
{

	sprintf(sp, "********** seznam definovanch font *********");
	PRINT
	sprintf(sp, "");
	PRINT

	while (p_vrchol != NULL) {
		sprintf(sp, "  font: '%s'", p_vrchol->p_nazev);
		PRINT
		sprintf(sp, "  typ: '%s'", p_vrchol->typ == 0 ? "veobecn" : "uivatelsk");
		PRINT
		sprintf(sp, "  kdovn: '%s'", p_vrchol->kodovani == 0 ? "Macintosh" : "Windows");
		PRINT
		sprintf(sp, "  poad: '%d'", p_vrchol->poradi);
		PRINT
		sprintf(sp, "");
		PRINT

/*		sprintf(sp, "  dal: '%p'", p_vrchol->p_dalsi);
		PRINT */
		p_vrchol = p_vrchol->p_dalsi;
	}
}

LOCAL void vypis_fonttbl(P_FONTTAB p_vrchol)
/*******************************************
 * vypi tabulku font definovanch vstupnm RTF souborem
 */
{
	while (p_vrchol != NULL) {
		sprintf(sp, "********** vpis tabulky font **********");
		PRINT
		sprintf(sp, "");
		PRINT
		sprintf(sp, "  jmno fontu: `%s'", p_vrchol->p_nazev);
		PRINT
		sprintf(sp, "  slo fontu: %lu", p_vrchol->cislo);
		PRINT
		sprintf(sp, "  rodina: %d", p_vrchol->rodina_fontu);
		PRINT
		sprintf(sp, "  poad: %d", p_vrchol->poradi);
		PRINT
/*		sprintf(sp, "adresa ASCII tabulky %p pro font `%s'", p_sfont->tab_znak, p_sfont->p_nazev);
		PRINT
		sprintf(sp, "pointer na tabulku znaku: %p", p_vrchol->p_tabulka_znak);
		PRINT
		sprintf(sp, "pointer na dalsi: %p", p_vrchol->p_dalsi);
		PRINT*/
		p_vrchol = p_vrchol->p_dalsi;
	}
}

LOCAL void vykonej_rzas(P_RTFZAS p_vrchol)
/*****************************************
 * vykon akci uloenou na vrcholu zsobnku
 */
{

	switch (p_vrchol->cislo_akce) {

		case UKONCIZAVORKU:
			if ((byl_pard == TRUE) && (rtfz != 1)) {
				uloz_text(SPSLOZENA);
			}
			break;

		case NULUJHVEZDU:
			hvezda = FALSE;
			break;

		case NASTAVFONTTBL:
			byl_fonttbl = TRUE;
			break;

		case NULUJPOZNAMKY:
			podcarou = FALSE;
			break;

		case UKONCIINDEX:
			uloz_text("}}$}");
			break;

		case OBNOVFONT:
			if ((byl_pard == TRUE) && (rtfz != 1)) {
				uloz_text(SPSLOZENA);
			}
			cislo_fontu = p_rzas->parametr;
			break;

		case RESETUJOBJEKTY:
			objekt = FALSE;
			typ_objektu = NEDEFINOVAN;
			preskoceni = TRUE;
			break;

		case RESETFONTBI:
			if ((byl_pard == TRUE) && (rtfz != 1)) {
				uloz_text(SPSLOZENA);
			}
			aktualni_rez = RM;
			break;

		default: sprintf(sp, "Kod prikazu: %d ", p_vrchol->cislo_akce);
							PRINT
							TNO("Neimplementovan pkaz.");
							break;
	}
}

LOCAL void uprav_cislovani(char retezec[], int cislo)
/****************************************************
 * uprav posledn dva znaky z formtu aa na formt nap. ac, kdy je cislo = 2
 */
{
	int cely;		/* pomocn promnn pro potn pepnacch znak aa na ad */
	int zbytek;
	int delka;	/* dlka upravovanho etzce */

	cely = cislo / MAXFONTPISMEN;
	zbytek = cislo % MAXFONTPISMEN;
	delka = strlen(retezec);
	retezec[delka - 2] += cely;
	retezec[delka - 1] += zbytek;
}

/*************************** konec souboru **********************************/
